/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************
 ***    AgpJntN3.c   ***
 ***********************/
#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"

#include	"GpType/GpType.h"


#include	"AgpEditTool.h"





int
agp_jnt_cut_brn( gp_array *agp, jnt_type *jnt, int bno )
{ 
jnt_type	*njnt;
brn_type	*b;
link_type	*link;
int	direction,	type;
vec2d	v;  


	if( jnt->brn_no == 1 )	return( -1 );

	if( jnt->type == JNT_N3 && bno == 0 ){
		agp_jnt_n3_split( agp, jnt );
		return( 1 );
	}




	b = jnt->brn[bno];
	if( b->type == BRN_NULL || b->type == BRN_IN )	return( -1 );


	v.x = jnt->gctr.x + b->ctr.x;
	v.y = jnt->gctr.y + b->ctr.y;
	link = b->link;
	direction = b->direction;
	jnt_untied_brn( jnt, bno, 1 );


	switch( link->type ){
	case NF_EDGE:
		type = JNT_EDGE;
		break;
	case NF_RIDGE:
		type = JNT_RIDGE;
		break;
	case NF_N3:
		type = JNT_RN3;
		break;
	}

	njnt = jnt_alloc_1( type, &v );
	jnt_connet_link( njnt, -1, link, direction);
	agp_jnt_insert( agp, njnt );

	return( 1 );
}

 


