/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************************
 ***    AgpJntEdgeReorder.c    ***
 *********************************/
 
#include	<stdio.h>
#include	<math.h>
 
#include	"Uigp/igp.h"
#include	"AgpEdit/AgpEditTool.h"
 
 
 
 
 
void
agp_jnt_edge_reorder( gp_array *agp, jnt_type *jnt )
{
brn_type	*b;
link_type	*l;
int     i,      j,	direct;
vec2d   v,	n;
vec2d	v0,	v1,	ctr,	p;
float	len,	a,	t,	h;
jnt_type	*njnt;
 
	for( i = 0 ; i < jnt->brn_no ; i++ ){
		b = jnt->brn[i];


		v.x = -b->link->u.y;
		v.y = b->link->u.x;
 
		if( b->direction == F_BEGIN ){
			v.x = -v.x;
			v.y = -v.y;
		}


		n.x = v.y;
		n.y = -v.x;

		len = b->link->len;


		for( j = 0 ; j < jnt->brn_no ; j++ ){
			if( j == i )	continue;
			b = jnt->brn[j];
			if( b->link->len < len )	continue;

			if( b->link->a == 0 )	continue;

			l = b->link;


			v0.x = -b->link->u.y;
			v0.y = b->link->u.x;
			if( b->direction == F_BEGIN ){
				v0.x = -v0.x;
				v0.y = -v0.y;
			}

			if( v.x * v0.x + v.y *v0.y <= 0 )	continue;


			t = 0.5 * l->len;
			h = l->c_prb * t * (t - l->len);
			v1.x = t * -l->u.y  +  h * l->u.x;
			v1.y = t *  l->u.x  +  h * l->u.y;
			if( b->direction == F_BEGIN ){
				v1.x = -v1.x;
				v1.y = -v1.y;
			}

			if( (n.x * v0.x + n.y *v0.y <= 0 ) ==
					n.x * v1.x + n.y *v1.y < 0 )
				continue;


			if( b->direction == F_BEGIN ){
				p.x = jnt->gctr.x - v1.x;
				p.y = jnt->gctr.y - v1.y;
				agp_link_split( agp, &jnt->gctr, l, &p );

				continue;
			}
			ctr.x = jnt->gctr.x - b->link->v.x;
			ctr.y = jnt->gctr.y - b->link->v.y;
			p.x = ctr.x + v1.x;
			p.y = ctr.y + v1.y;
			agp_link_split( agp, &ctr, l, &p );
		}
	}






	for( i = 0 ; i < jnt->brn_no-1 ; i++ ){
		b = jnt->brn[i];


		direct = INV_FLAG( b->direction );

		if( b->link->p[direct].bno < 0 )	continue;

		njnt = b->link->p[direct].p.jnt;

		a = ABS( b->link->a );
		l = b->link;

		


		for( j = i+1 ; j < jnt->brn_no ; j++ ){


			b = jnt->brn[j];


			direct = INV_FLAG( b->direction );

			if( b->link->p[direct].p.jnt == njnt )	break;
		}

		if( j == jnt->brn_no )	continue;


		if( ABS( b->link->a) < a )
			b = jnt->brn[i];



		if( b->direction == F_END ){
			ctr.x = jnt->gctr.x - b->link->v.x;
			ctr.y = jnt->gctr.y - b->link->v.y;
		}
		else	ctr = jnt->gctr;

		l = b->link;

		t = 0.5 * l->len;
		h = l->c_prb * t * (t - l->len);
		p.x = ctr.x + t * -l->u.y  +  h * l->u.x;
		p.y = ctr.y + t *  l->u.x  +  h * l->u.y;

		agp_link_split( agp, &ctr, l, &p );
	}

}
