/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************************************************************\

                            AgpLinkFilter.c				

link_type *
agp_link_filter( gp_array *agp, vec2d *ctr, link_type *link, 
				   float min_width );

\************************************************************************/
#include        <stdio.h>   
#include	<math.h>

#include        "Uigp/igp.h"
#include        "Uprm/prm.h"

#include        "GpType/GpType.h"

#include        "AgpEditTool.h"

#include        "LinkTool/LinkTool.h"



link_type *
agp_link_filter( gp_array *agp, vec2d *ctr, link_type *link, 
									float min_width )
{
jnt_type	*jnt1 = NULL, *jnt2 = NULL;
link_type	*slink, *l1, *l2;

	if ( !link )
		return NULL;

	for ( l1 = link; l1; l1 = LINK_NEXT(l1) )
		l2 = l1;
	jnt1 = link->p[F_BEGIN].p.jnt;
	if ( link->p[F_BEGIN].p.jnt != l2->p[F_END].p.jnt )
		jnt2 = l2->p[F_END].p.jnt;

	agp_lnf_clear_link( ctr, link, agp );
	agp_jnt_untied( agp, jnt1);
	if ( jnt2 )
		agp_jnt_untied( agp, jnt2);

	slink = link;
	slink = link_filter( ctr, slink, min_width );

	agp_jnt_insert( agp, jnt1 );
	if ( jnt2 )
		agp_jnt_insert( agp, jnt2 );

	agp_lnf_link( ctr, slink, agp );
	jnt_load_nf_end_link( slink );
	if( slink->type == NF_N3 )
		link_width_bes( slink );

	return slink;
}

