/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************************
 ***    AgpLinkN3rToRidge.c    ***
 ******************************/
#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"


#include	"GpType/GpType.h"


#include	"AgpEditTool.h"



void
agp_link_N3R_to_ridge( gp_array *agp, link_type * link )
{
link_type	*l,	*ll;
jnt_type	*jnt;


	if( link->type != NF_N3R )	return;

	while( ( l = LINK_PREV(link) ) != NULL )	link = l;
	jnt = link->p[0].p.jnt;

	if( jnt->type == JNT_N3 )
		agp_jnt_n3_split( agp, jnt );

	jnt->type = JNT_RIDGE;

	for( l = link ; l != NULL ; l = LINK_NEXT(l ) ){
		l->type = NF_RIDGE;


		link_delete_in( l, F_RIGHT );
		link_delete_in( l, F_LEFT );

		ll = l;
	}


	jnt = ll->p[1].p.jnt;
	if( jnt->type == JNT_N3 )
		agp_jnt_n3_split( agp, jnt );

	jnt->type = JNT_RIDGE;
}

