/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************************
 ***	AgpPolinkInsert.c   ***
 ******************************/
#include <malloc.h>
#include <math.h>



#include	"AgpEdit/AgpEditTool.h"
#include	"LinkTool/LinkTool.h"
#include	"N3Prime/N3Prime.h"
#include        "RlLink/RlType.h"

/*
static link_type *	agp_polylink_split_line( link_type *link,
							float max_len );
*/

link_type *
agp_polylink_insertA( gp_array *agp, vec2d *ctr, link_type *link, int Fclose )
{
box2d box;

	BOX2D_SET( box, 1, agp->row - 1, 1, agp->column - 1 ) ;
	
	link = link_clip(ctr, link,&box);

	*ctr = link->ctr;
	

	polylink_simplify( ctr, &link );

	link = polylink_max_len( link, 12.0F );

//	for( l = link ; l != NULL ; l = LINK_NEXT(l) )	l->type = NF_EDGE;

	agp_polylink_default_profile( agp, ctr, link, TRUE );


	agp_polylink_insert( agp, ctr, link, Fclose );

	return link;	
}



void
agp_polylink_insert( gp_array *agp, vec2d *ctr, link_type *link, int Fclose )
{
jnt_type	*jnt,	*jnt1;
vec2d	v;
link_type	*l;



	for( l = link, v = *ctr ; l != NULL ; l = LINK_NEXT(l) ){
		v.x += l->v.x;
		v.y += l->v.y;
		if( LINK_NEXT(l) == NULL )	break;
	}

	jnt = jnt_alloc_1( JNT_EDGE, ctr );
	agp_jnt_insert( agp, jnt );

	if( Fclose == 0 ){
		jnt1 = jnt_alloc_1( JNT_EDGE, &v );
		agp_jnt_insert( agp, jnt1 );
	}
	else	jnt1 = jnt;

	jnt_connet_link( jnt, -1, link, F_BEGIN );
	jnt_connet_link( jnt1, -1, l, F_END );


	jnt_set_aux( jnt );
	jnt_set_aux( jnt1 );


	if( Fclose == 1 )
		jnt_load_nf_end_link( link );

	agp_lnf_link( ctr, link, agp );
}




/*
static link_type * 
agp_polylink_split_line( link_type *link, float max_len )
{
link_type	*l,	*l0,	*l1;
vec2d	p;



	for( l = link ; l != NULL ; l = LINK_NEXT(l) ){

		if( ABS(l->a) > 0.01 || l->len < max_len  )
			continue;

		p.x = l->ctr.x + l->v.x;
		p.y = l->ctr.y + l->v.y;
		l0 = links_from_line( &l->ctr, &p, max_len, l->type, &l1 );

		l0->p[0] = l->p[0];
		l1->p[1] = l->p[1];

		if( LINK_PREV(l0) != NULL )
			l0->p[0].p.l->p[1].p.l = l0;

		if( LINK_NEXT(l1) != NULL )
			l1->p[1].p.l->p[0].p.l = l1;

		if( l == link ) link = l0;

		free( l );

		l = l1;
	}

	return( link );
}
*/


void
agp_polylink_default_profile( gp_array *agp, vec2d *ctr, link_type *link, int Falloc )
{
link_type	*l,	*pl;
vec2d	v;
int	Fn3_prime;

	if( (Fn3_prime = agp->Fn3_prime) == 0 )	n3_prime_agp( agp);

	pl = NULL;
	for( l = link, v = *ctr ; l != NULL ; l = LINK_NEXT(l) ){
		agp_default_profile( agp, &v, l, F_BEGIN, 0.5, Falloc );

		if( pl != NULL ){
			pl->pr[1] = l->pr[0];
			pl->width[1] = l->width[0];
		}


		if( LINK_NEXT(l) == NULL )
			agp_default_profile( agp, &v, l, F_END, 0.5, Falloc );

		v.x += l->v.x;
		v.y += l->v.y;

		pl = l;
	}

	if( Fn3_prime == 0 )	n3_prime_free( agp);
}
