/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*************************
 ***   AgpLayerCut.c   ***
 *************************/

#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"

#include	"GpType/GpType.h"

#include	"AgpTool/AgpTool.h"
#include	"AgpEdit/AgpEditTool.h"
#include	"AgpLayer.h"



int
agp_layer_cut( gp_array *agp, int mbr )
{
gp_type	*gp;
hunch_type	*h,	**hpp;
bgp_type	*bp,	**bpp;
link_type	*l;
int	i,	j;



	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){

			gp = &agp->gp[i][j];

			bpp = &gp->bgp;
			for( bp = gp->bgp ; bp != NULL ; ){
				if( !( mbr & (1<<bp->br)) ){
					bpp = &bp->p;
					bp = bp->p;
					continue;
				}
				*bpp = bp->p;
				free( bp );
				bp = *bpp;
			}


			hpp = &gp->hunch;
			for( h = gp->hunch ; h != NULL ; ){
				if( !( mbr & (1<<h->br)) ){
					hpp = &h->nh;
					h = h->nh;
					continue;
				}
				*hpp = h->nh;
				free( h );
				h = *hpp;
			}



			for( l = gp->link ; l != NULL ; ){
				if( LINK_PREV(l) != NULL ||
						!( mbr & (1<<l->br)) ){
					l = l->nl;
					continue;
				}


				agp_polylink_delete( agp, l );

				l = gp->link;
			}
		}

	agp->ad->Mbr &= ~mbr;


	for( i = 0, j = 0 ; i < agp->ad->br_no ; i++ ){
		if( mbr & ( 1<< agp->ad->abr[i].no ) )	continue;
		
		if( j < i )
			agp->ad->abr[j++] = agp->ad->abr[i];
		else	j++;
	}
	agp->ad->br_no = j;



	for( i = 0 ; i < agp->layer_no ; i++ )
		if( agp->layer[i]->Mbr & mbr )	break;

	if( i >= agp->layer_no )	return( 1 );

	agp->layer[i]->Mbr &= ~mbr;

	if( agp->layer[i]->Mbr != 0 )	return( 1 );

	free(  agp->layer[i] );
	agp->layer_no--;

	for(  ; i <  agp->layer_no ; i++ )
		agp->layer[i] = agp->layer[i+1];

	return( 2 );
}
