/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	AgpLayerHole.c	***
 *************************/
#include	"Uigp/igp.h"


#include        "GpType/GpType.h"


static int	agp_layer_hole_jnt( jnt_type *jnt, int br );


int
agp_layer_hole( gp_array *agp, int br, vec2d *p )
{
gp_type		*gp;
jnt_type	*jnt;
int	i,	j;


	for( i = 1 ; i < agp->Ni-1 ; i++ )
		for( j = 1 ; j < agp->Nj-1 ; j++ ){
			gp = &agp->gp[i][j];

			for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj )
				if( agp_layer_hole_jnt( jnt, br ) == 1 ){
					*p = jnt->gctr;
					return( 1 );
				}

		}

	return( 0 );
}



static int
agp_layer_hole_jnt( jnt_type *jnt, int br )
{
brn_type	*b;
int	i,	no,	Fbr;

	if( jnt->type == JNT_RIDGE )	return( 0 );

	no = Fbr = 0;
	for( i = 0 ; i < jnt->brn_no ; i++ ){
		b = jnt->brn[i];

		if( b->type == BRN_NULL || b->type == BRN_IN )	continue;

		if( b->link->Fbr == 0 )	continue;

		no++;

		if( b->link->br == br )	Fbr = 1;
	}

	if( Fbr == 1 && no == 1 )	return( 1 );

	return( 0 );
}
