/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************************
 ***   AgpLayerRenaumbring.c   ***
 *********************************/

#include	<stdio.h>

#include	"Uigp/igp.h"

#include	"GpType/GpType.h"

#include	"AgpLayer.h"



int
agp_layer_renumbering( gp_array *agp, int id0, int aId[] )
{
adepth_type	*ad;
gp_type	*gp;
hunch_type	*h;
bgp_type	*bp;
link_type	*link;

int	i,	j,	flag;
int	id;
int	mbr,	lmbr,	gmbr;
int	lno;

	for( i = 0 ; i < 256 ; i++ )
		aId[i] = -1;

	flag = -1;
	gmbr = 0;
	for( i = 0, id = id0 ; i < agp->layer_no ; i++ ){
		lmbr = 0;
		lno = 0;
		for( mbr = agp->layer[i]->Mbr, j = 0 ; mbr != 0 ; mbr >>= 1, j++ ){
			if( mbr & 0x01 ){
				aId[j] = id;
				if( j != id )	flag = 1;

				lmbr |= 1 << id;
				lno++;

				id++;
			}
		}

		agp->layer[i]->Mbr = lmbr;
		agp->layer[i]->nSl = lno;
		agp->layer[i]->iSl0 = id - lno;
		gmbr |= agp->layer[i]->Mbr;
	}

	if( flag < 0 )	return( flag );


	ad = agp->ad;

	ad->Mbr = gmbr;



	for( i = 0, j = 0 ; i < ad->br_no ; i++ ){
		if( aId[ ad->abr[i].no ] == -1 )	continue;
		if( j < i )	ad->abr[j] = ad->abr[i];

		ad->abr[j].no = aId[ ad->abr[j].no ];
		j++;
	}
	ad->br_no = j;





	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){

			gp = &agp->gp[i][j];

			for( bp = gp->bgp ; bp != NULL ; bp = bp->p ){
				bp->br = aId[bp->br ];
			}


			for( h = gp->hunch ; h != NULL ; h = h->nh ){
				h->br = aId[h->br ];
			}



			for( link = gp->link ; link != NULL ; link = link->nl ){
				link->br = aId[link->br ];
				if( link->br1 > 0 )
					link->br1 = aId[link->br1 ];
			}
		}


	return( 1 );
}

