/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/**************************
 ***	AgpBrList.c	***
 *************************/

#include        <stdio.h>   
#include	<math.h>

#include        "AgpTool.h"


static void	agp_br_add( int Abr[], int *Br_no, int br );

void
agp_br_mask( gp_array *agp, int *Mnf, int *Mbg, int *Fbr )
{
gp_type	*gp;
link_type	*l;
hunch_type	*hunch;
bgp_type	*bgp;
 
int	i,	j;

	*Mnf = *Mbg = *Fbr = 0;

 
	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];
 

		for( bgp = gp->bgp ; bgp != NULL ; bgp = bgp->p )
			*Mbg |= ( 1<< bgp->br);


		for( hunch = gp->hunch ; hunch != NULL ; hunch = hunch->nh )
			*Mnf |= ( 1<< hunch->br);


		for( l = gp->link ; l != NULL ; l = l->nl ){
			*Mnf |= ( 1<< l->br);
			*Fbr |= l->Fbr;
		}
	    }
}




void
agp_br_list( gp_array *agp )
{
gp_type	*gp;
link_type	*l;
hunch_type	*hunch;
bgp_type	*bgp;
int	Abr[256],	Br_no;
 
int	i,	j;

	Br_no = 0;

 
	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];
 

		for( bgp = gp->bgp ; bgp != NULL ; bgp = bgp->p )
			agp_br_add( Abr, &Br_no, bgp->br );


		for( hunch = gp->hunch ; hunch != NULL ; hunch = hunch->nh )
			agp_br_add( Abr, &Br_no, hunch->br );


		for( l = gp->link ; l != NULL ; l = l->nl )
			agp_br_add( Abr, &Br_no, l->br );
	    }
}


static void
agp_br_add( int	Abr[], int *Br_no, int br )
{
int	i;

	for( i = 0 ; i < *Br_no ; i++ )
		if( Abr[i] == br )	return;

	if( *Br_no == 256 )
		error( "agp_br_add", "out of range" );

	Abr[*Br_no] = br;
	(*Br_no)++;

	fprintf( stderr, "%d\n", br );
}
