/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/****************************
 ***	AgpConnectJnt.c   ***
 ****************************/
#include        <stdio.h>   
#include	<math.h>

#include        "AgpEdit/AgpEditTool.h"


void
agp_connect_jnt( gp_array *agp )
{
gp_type	*gp;
jnt_type	*jnt,	*cjnt;
 
int	i,	j;

 
	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];
 
		for( jnt = gp->jnt ; jnt != NULL ; ){

			cjnt = jnt;
			jnt = jnt->nj;

			if( cjnt->brn_no != 2 )	continue;

			switch( cjnt->type ){
			case JNT_RIDGE:  
				agp_jnt_ridge_connect( agp, gp, cjnt);
			    break;

			case JNT_EDGE:
				agp_jnt_edge_connect( agp, gp, cjnt );
			    break;

			case JNT_RN3:
				agp_jnt_rn3_connect( agp, gp, cjnt);
			    break;
			}
		}
	}
}
