/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	AgpConst.c	***
 **************************/
#include	<stdio.h>   
#include	<math.h>

#include	"AgpTool.h"



static void	agp_bgp_add( gp_type *gp, float x, float y,
					qcolor_type val[SP_NO] );




gp_array *
agp_const( int row, int column, int bgp,
			int red, int green, int blue )
{
gp_array	*agp;
gp_type	*gp;
qcolor_type	val[SP_NO];
float	Hb;
int	i,	j;

	agp = agp_alloc();

	agp_clear( agp, bgp, row, column, 144, 144 );
	agp->color_type = AGP_RGB;

	val[SP_R] = F2QCOLOR(red);
	val[SP_G] = F2QCOLOR(green);
	val[SP_B] = F2QCOLOR(blue);

	Hb = 0.25 * agp->bgp;

        for( i = 1 ; i < agp->Ni-1 ; i ++ )
        	for( j = 1 ; j < agp->Nj-1 ; j ++ ){
			gp = &agp->gp[i][j];

			agp_bgp_add( gp, -Hb, -Hb, val );

			agp_bgp_add( gp, -Hb, +Hb, val );

			agp_bgp_add( gp, +Hb, -Hb, val );
	
			agp_bgp_add( gp, +Hb, +Hb, val );
		}

	return( agp );
}



void
agp_const1( gp_array *agp,
			int red, int green, int blue )
{
gp_type	*gp;
qcolor_type	val[SP_NO];
float	Hb;
int	i,	j;

	agp->color_type = AGP_RGB;

	val[SP_R] = F2QCOLOR(red);
	val[SP_G] = F2QCOLOR(green);
	val[SP_B] = F2QCOLOR(blue);

	Hb = 0.25 * agp->bgp;

        for( i = 1 ; i < agp->Ni-1 ; i ++ )
        	for( j = 1 ; j < agp->Nj-1 ; j ++ ){
			gp = &agp->gp[i][j];

			agp_bgp_add( gp, 0, 0, val );

		}

}


static void
agp_bgp_add( gp_type *gp, float x, float y, qcolor_type val[SP_NO] )
{
bgp_type	*bp;
	bp = BGP_ALLOC();
	bp->ctr.x = x;
	bp->ctr.y = y;

	bp->val[0] = val[0];
	bp->val[1] = val[1];
	bp->val[2] = val[2];

	bp->br = 0;

	
	bp->p = gp->bgp;
	gp->bgp = bp;
}
