/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	AgpJntBrn4.c   ***
 **************************/
#include        <stdio.h>   
#include	<math.h>

#include        "Uigp/igp.h"
#include        "Uprm/prm.h"

#include        "GpType/GpType.h"

#include        "AgpTool.h"


static void	agp_jnt_brn4_one( jnt_type *jnt, gp_array *agp );


void
agp_jnt_brn4( gp_array *agp )
{
gp_type	*gp;
jnt_type	*jnt;
int	i,	j;

	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
			if( jnt->brn_no < 4 )	continue;


			agp_jnt_brn4_one( jnt, agp );
		}
	    }
}


static void
agp_jnt_brn4_one( jnt_type *jnt, gp_array *agp )
{
brn_type	*b;
jnt_type	*njnt,	*ajnt[4];
int	nbno,	abno[4];
link_type	*l;
int	no,	i,	k;


	for( k = 0, no = 0 ; k < jnt->brn_no ; k++ )
		if( jnt->brn[k]->direction == F_BEGIN )	no++;
	
	if( no < 4 )	return;

	for( i = 0 ; i < jnt->brn_no ; i++ ){

		b = jnt->brn[i];

		if( b->direction == F_BEGIN ){
			for( l = b->link ; LINK_NEXT(l)!= NULL ;
						l = LINK_NEXT(l));
			njnt = l->p[F_END].p.jnt;
			nbno = l->p[F_END].bno;
		}
		else	{
			for( l = b->link ; LINK_PREV(l)!= NULL ;
                                                l = LINK_PREV(l));
			njnt = l->p[F_BEGIN].p.jnt;
			nbno = l->p[F_BEGIN].bno;
		}


		if( njnt->brn_no < 4 ){
			agp_lnf_clear_link( &jnt->gctr, b->link, agp );
			link_inverse( b->link );
			agp_lnf_link( &njnt->gctr, njnt->brn[nbno]->link, agp );

			jnt_set_aux( jnt );
			jnt_set_aux( njnt );
			return;
		}

		ajnt[i] = njnt;
		abno[i] = nbno;


	}


	for( i = 0 ; i < jnt->brn_no ; i++ ){
		njnt = ajnt[i];
		nbno = abno[i];

		for( k = 0, no = 0 ; k < njnt->brn_no ; k++ )
			if( njnt->brn[k]->direction == F_BEGIN )	no++;

		if( no < 3 ){
			agp_lnf_clear_link( &jnt->gctr, b->link, agp );
			link_inverse( jnt->brn[i]->link );
			agp_lnf_link( &njnt->gctr, njnt->brn[nbno]->link, agp );
			return;
		}
	}
}
