/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	AgpLinkNo.c   ***
 ************************/
#include        <stdio.h>   
#include	<math.h>

#include        "Uigp/igp.h"
#include        "Uprm/prm.h"

#include        "GpType/GpType.h"

#include        "AgpEdit/AgpEditTool.h"

#include        "AgpTool.h"




int
agp_link_no( gp_array *agp, int max_no )
{
gp_type	*gp;
jnt_type	*jnt;
brn_type	*b;
link_type	*l;
int	i,	j,	k,	no;
vec2d	ctr;
int	Fret;

	Fret = 0;

	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){

			for( k = 0 ; k < jnt->brn_no ; k++ ){
				b = jnt->brn[k];
				if( b->type == BRN_NULL )	continue;
				if( b->type == BRN_IN )	continue;

				if( b->direction != F_BEGIN )	continue;

				if( b->type != BRN_EDGE )	continue;

				for( l = b->link, no = 0, ctr = jnt->gctr ; l != NULL ;
							l = LINK_NEXT(l), no++ ){

					if( no > max_no ){

						agp_link_to_jnt( agp, &ctr, l );
						no = 0;

						Fret = 1;
					}
					ctr.x += l->v.x;
					ctr.y += l->v.y;
				}

			}
	    }
		}

	return( Fret );
}
