/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*************************
 ***	AgpLinkProf.c  ***
 *************************/
#include	"AgpTool.h"

static void agp_link1_profile( link_type *l, int moldTypeProfile );
#define MOLD_PROFILE_VAL_EQ_BVAL 1
#define MOLD_PROFILE_VAL_DARK_BVAL 2

void
agp_link_profile( gp_array *agp, int moldTypeProfile )
{
gp_type		*gp;
link_type	*link;
int			i, j;

	if ( !agp || !moldTypeProfile )
		return;

	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){
			gp = &agp->gp[i][j];
			for( link = gp->link ; link != NULL ; link = link->nl )
				agp_link1_profile( link, moldTypeProfile );
		}
}


static void
agp_link1_profile( link_type *l, int moldTypeProfile )
{
edge_type	*e;
float k = 1.0;

	if ( moldTypeProfile == MOLD_PROFILE_VAL_DARK_BVAL )
		k = 0.5;

	e = l->pr[0].edge;
	e->side[F_RIGHT].val[SP_R] = e->side[F_RIGHT].bval[SP_R]*k;
	e->side[F_RIGHT].val[SP_G] = e->side[F_RIGHT].bval[SP_G]*k;
	e->side[F_RIGHT].val[SP_B] = e->side[F_RIGHT].bval[SP_B]*k;

	e->side[F_LEFT].val[SP_R] = e->side[F_LEFT].bval[SP_R]*k;
	e->side[F_LEFT].val[SP_G] = e->side[F_LEFT].bval[SP_G]*k;
	e->side[F_LEFT].val[SP_B] = e->side[F_LEFT].bval[SP_B]*k;

	if ( LINK_NEXT(l) == NULL )
	{
		e = l->pr[1].edge;
		e->side[F_RIGHT].val[SP_R] = e->side[F_RIGHT].bval[SP_R]*k;
		e->side[F_RIGHT].val[SP_G] = e->side[F_RIGHT].bval[SP_G]*k;
		e->side[F_RIGHT].val[SP_B] = e->side[F_RIGHT].bval[SP_B]*k;

		e->side[F_LEFT].val[SP_R] = e->side[F_LEFT].bval[SP_R]*k;
		e->side[F_LEFT].val[SP_G] = e->side[F_LEFT].bval[SP_G]*k;
		e->side[F_LEFT].val[SP_B] = e->side[F_LEFT].bval[SP_B]*k;
	}
}
