/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/********************
 ***	AgpNf.c   ***
 ********************/

#include        <stdio.h>
#include        <math.h>

#include        "Uigp/igp.h"

 
#include        "AgpTool/AgpTool.h"


 
int
agp_nf( gp_array *agp, box2d *box, int nf[NF_TYPES] )
{
int	i0,	j0,	i1,	j1;
int	i,	j,	no;
gp_type *gp;
link_type	*l;
hunch_type	*h;
jnt_type	*jnt;
 
 
	if( box != NULL ){
		i0 = ( box->x0 + agp->bgp )*agp->inv_bgp;
		j0 = ( box->y0 + agp->bgp )*agp->inv_bgp;
 
		i1 = ( box->x1 + agp->bgp )*agp->inv_bgp;
		j1 = ( box->y1 + agp->bgp )*agp->inv_bgp;
 
		if( i0 < 0 )    i0 = 0;
		if( i1 >= agp->Ni )     i1 = agp->Ni -1;
		if( j0 < 0 )    j0 = 0;
		if( j1 >= agp->Nj )     j1 = agp->Nj -1;
        }
        else    {
                i0 = j0 = 0;
                i1 = agp->Ni -1;
                j1 = agp->Nj -1;
        }   
 
 

	for( i = 0 ; i < NF_TYPES ; i++ )	nf[i] = 0;

 
	no = 0;
	for( i = i0 ; i <= i1 ; i++ )
	    for( j = j0 ; j <= j1 ; j++ ){
		gp = &agp->gp[i][j];
 

		for( h = gp->hunch ; h != NULL ; h = h->nh ){
			nf[ h->type ] ++;

			no++;
		}


		for( l = gp->link ; l != NULL ; l = l->nl ){

			nf[ l->type ] ++;

			no++;
		}


		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
			nf[ NF_JNT ] ++;
		}
	}

	return( no );
}
