/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************************
 ***	AgpLayerProfileWidth.c   ***
 ***********************************/
#include        <stdio.h>   
#include		<math.h>

#include        "AgpTool/AgpTool.h"


static void		agp_profile_width_edge(edge_type *e,float w);
static void		agp_profile_width_n3(n3_type *e);


void 
agp_profile_width(gp_array *agp,float width,int mbr )
{
	gp_type	*gp;
link_type	*link;


 
int	i,	j;

	

	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];
 		


		for( link = gp->link ; link != NULL ; link = link->nl ){
			if( !(mbr & (1<<link->br)) )	
				continue;

			switch( link->type ){
			case NF_N3:
				agp_profile_width_n3( link->pr[0].n3 );
				if( LINK_NEXT( link ) == NULL )
					agp_profile_width_n3( link->pr[1].n3  );
			    break;

			case NF_EDGE:
				agp_profile_width_edge( link->pr[0].edge,width );
				if( LINK_NEXT( link ) == NULL )
					agp_profile_width_edge( link->pr[1].edge ,width);
			    break;
			
			}
		}
	 }
}


static void agp_profile_width_edge(edge_type *e,float w)
{
	e->width = w;
	e->side->val[0]=e->side->bval[0];
	e->side->val[1]=e->side->bval[1];
	e->side->val[2]=e->side->bval[2];
}

static void agp_profile_width_n3(n3_type *e)
{
	e->side->val[0]=e->side->bval[0];
	e->side->val[1]=e->side->bval[1];
	e->side->val[2]=e->side->bval[2];
}