/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_FILTER_

#define		_FILTER_


#include	"Uprm/prm.h"
#include	"GpType/GpType.h"


	/* FilterAgp.c */

void	filter_get_prm( GP_prm **prm, int *prm_no,void (**check)() );

void	filter_init( char *dir, int Lfilter );

void	filter_set_lprm();

void	filter_agp( gp_array *agp );

void	filter_percent_agp( gp_array *agp, box2d *box,
					float Phunch, float Pridge );



	/* FilterRh2Hunch.c */
void	filter_rhunch_to_hunch_get_prm( GP_prm **prm,
					int *prm_no,void (**check)() );

void	filter_rhunch_to_hunch_agp( gp_array *agp );



	/* FilterEdge.c */
void	filter_edge_get_prm(GP_prm **prm, int *prm_no, void (**check)() );

int	filter_edge( gp_array *agp );


	/* FilterN3.c */
void	filter_n3( gp_array *agp );



	/* FilterHunch.c */
void	filter_hunch_agp( gp_array *agp, box2d *box,
                        float rval_t, float lm_t, float len_t );

int	filter_hunch_agp_aux( gp_array *agp, box2d *box, int val[256] );


	/* FilterRidge.c */
void	filter_ridge_agp( gp_array *agp, box2d *box, float rval_t );
int	filter_ridge_agp_aux( gp_array *agp, box2d *box, int val[256] );


	/* FilterLinkLen.c */
void filter_len_edge( gp_array *agp, float len_min );
void filter_len_n3_to_edge( gp_array *agp, float len_min );


#endif /* #ifndef _FILTER_ */		
 		
