/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************************************************************/

/*                            FilterLinkLen.c				*/ 

/************************************************************************/
#include    <stdio.h>   
#include	<math.h>

#include    "Uigp/igp.h"
#include    "GpType/GpType.h"

#include	"AgpTool/AgpTool.h"
#include	"AgpEdit/AgpEditTool.h"

void
filter_len_edge( gp_array *agp, float len_min )
{
gp_type		*gp;
link_type	*link, *nl;
vec2d		ctr;
int			i,	j;

	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){

			gp = &agp->gp[i][j];

			for( link = gp->link ; link != NULL ; link = nl){

				nl = link->nl;

				//if( link->type != NF_EDGE )
				//	continue;

				if( link->Fbr != 0 )
					continue;

				if( link->len > len_min )
					continue;

				if( LINK_NEXT(link) == NULL && LINK_NEXT(link) == NULL )
					continue;
				
				ctr.x = gp->ctr.x + link->ctr.x;
				ctr.y = gp->ctr.y + link->ctr.y;

				agp_link_delete( agp, &ctr, link );
			}
		}
}


void
filter_len_n3_to_edge( gp_array *agp, float len_min )
{
gp_type		*gp;
link_type	*link;
link_type	*links[1000];
vec2d		ctr;
int			i, j, k, n;

	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){

			gp = &agp->gp[i][j];

			n = 0;

			for( link = gp->link ; link != NULL ; link = link->nl)
			{
				if( link->type != NF_N3 )
					continue;

				if( link->len > len_min )
					continue;

				if( LINK_NEXT(link) == NULL && LINK_NEXT(link) == NULL )
					continue;

				links[n++] = link;
			}

			for ( k = 0; k < n; k++ )
			{
				link = links[k];

				ctr.x = gp->ctr.x + link->ctr.x;
				ctr.y = gp->ctr.y + link->ctr.y;


				agp_link_n3_to_edge( agp, &ctr, link );
			}
		}
}


