/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include        <stdio.h>
#include        <math.h>

#include        "Uigp/igp.h"

#include        "Uprm/prm.h"
 
#include        "GpType/GpType.h"
#include        "Filter.h"


 
static float      RHwidth = 1.0;


static GP_prm  P2F_params[]    =    {
	{"RH-width-K", (char*)&RHwidth, PRM_FLOAT, "%.2f", "1.0"},
};



static int	filter_rhunch_to_hunch( hunch_type *h );



void
filter_rhunch_to_hunch_get_prm( GP_prm **prm, int *prm_no,void (**check)() ) 
{
        *prm    = P2F_params;
        *prm_no  = PRM_NUMBER(P2F_params);
        *check = NULL;
}
 
 


void
filter_rhunch_to_hunch_agp( gp_array *agp )
{
gp_type 	*gp;
int	i,	j;
hunch_type	*h;

	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){

			gp = &agp->gp[i][j];

			for( h = gp->hunch ; h != NULL ; h = h->nh ){
				if( h->type != NF_RH )	continue;

				filter_rhunch_to_hunch( h );
			}
		}

}




static int
filter_rhunch_to_hunch( hunch_type *h )
{
	if( h->g.width * RHwidth < h->g.len )	return( 0 );

	h->type = NF_HUNCH;
/*
	if( h->g.len < h->g.width )
		h->g.len = h->g.width;
*/
	h->g.len += h->g.width;

	hunch_set_aux( h );

	return( 1 );
}
