/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	 ZpType.h	***
 **************************/
  
#ifndef		_BFL_TYPE_
#define		_BFL_TYPE_

#include	"Uigp/igp.h"


#define BF32

#ifdef BF32
typedef struct  bfL_type {

	u_int	f0;
}	bfL_type;




#define		BFL_CLEAR( b )		( (b).f0 = 0 )

#define		BFL_IS_CLEAR( bf )	( (bf).f0 == 0 )

#define		BFL_SET_BIT( b, i )		( (b).f0 |= ( 1L<<i ))

#define		BFL_IS_BIT_SET( b, i )	( (b).f0 & ( 1L<<i ))

#define		BFL_SET_OR( bf, b )	((bf).f0 |= (b).f0 ) 
#define		BFL_SET( bf, b )	((bf).f0 |= (b).f0 ) 

#define		BFL_UNSET( bf, b )	((bf).f0 &= ~(b).f0 ) 

#define		BFL_AND( b, b1 )		( (b).f0 & (b1).f0 )


#define		BFL_EQUAL( b, b1 )		( (b).f0 == (b1).f0 )



#define		BFL_IS_IN( b, b1 )		( ( (b).f0 & (b1).f0 ) == (b1).f0 )

#endif



#ifdef BF64
typedef struct  bfL_type {

	u_int	f0;
	u_int	f1;
}	bfL_type;




#define		BFL_CLEAR( bf )		( bf.f0 = bf.f1 = 0 )
#define		BFL_IS_CLEAR( bf )	( bf.a0 == 0 && bf.a1 == 0)

#define		BFL_SET_BIT( b, i )		if( i < 32 )	b.f0 | = ( 1<<i ); \
									else	b.f1 |= ( 1 << ( i - 32 );
#define		BFL_IS_BIT_SET( b, i )		( i < 32 ) ? ( b.f0 & ( 1<<i )) : ( b.f1 & ( 1<<(i-32) )) )


#define		BFL_SET_OR( bf, b )	((bf).f0 |= (b).f0, (bf).f1 |= (b).f1  ) 
#define		BFL_SET( bf, b )	((bf).f0 |= (b).f0, (bf).f1 |= (b).f1  ) 

#define		BFL_UNSET( bf, b )	((bf).f0 &= ~(b).f0, (bf).f1 &= ~(b).f1 ) 

#define		BFL_AND( b, b1 )		( ((b).f0 & (b1).f0) || ((b).f1 & (b1).f1) )


#define		BFL_EQUAL( b, b1 )		( (b).f0 == (b1).f0 && (b).f1 == (b1).f1 )



#define		BFL_IS_IN( b, b1 )		( ( (b).f0 & (b1).f0 ) == (b1).f0 && ( (b).f1 & (b1).f1 ) == (b1).f1 )


#endif





#endif
