/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**********************
 ***	QxyType.h   ***
 **********************/

#ifndef         QXY_TYPE
#define         QXY_TYPE

#include	"Configuration.h"
#include        "Uvec/Vec2d.h" 


//#define QXY_FLOAT
#define QXY_SHORT


#ifdef QXY_SHORT
typedef short qxy_type;

#define QXY_SFP		4
#define	QXY_F2FP	16
#define QXY_UNIT	16


#define	QXY2F( a )	( (a) * 0.0625 )
#define	F2QXY( a )	( (int)((a) * 16.0) )


typedef struct vec2dF {
        qxy_type        x;
        qxy_type        y;
} vec2dF;


#endif




#ifdef QXY_FLOAT
typedef float qxy_type;
 
#define QXY_UNIT     1
 
#define QXY2F( a )   ( a )
#define F2QXY( a )   ( a )


typedef vec2d  vec2dF;

 
#endif



/*
#define	F2QXY16( a )	(((int)(a*16))*0.0625)
#define	F2QXY16( a )	(a)

#define F2QXY16( a )           ( ( (a) < 0 )?  \
                                (( ((int)((a)*8)) - 0.5) *0.125 ) : \
                                (( ((int)((a)*8)) + 0.5) *0.125 ) )
*/


#define F2QXY16( a )           (( ((int)((a)*8)) + 0.5) *0.125 )






#endif
