/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include        "Uigp/igp.h"
#include	"InfIn.h"


#include        "GpType/GpType.h"


static struct INF_BGP {
	inf	val[SP_NO];
} Ibgp;

static int	Ibgp_no;

void
inf_bgp_init()
{
	Ibgp.val[SP_Y] = Inf_init;
	Ibgp.val[SP_Q] = Inf_init;
	Ibgp.val[SP_A] = Inf_init;

	Ibgp_no = 0;
}



void
inf_bgp( gp_array *agp )
{
gp_type *gp;
int     i,      j;
bgp_type	*bp;
 
	for( i = 0 ; i < agp->Ni ; i++ )
		for( j = 0 ; j < agp->Nj ; j++ ){
			gp = &agp->gp[i][j];

			for( bp = gp->bgp ; bp != NULL ; bp = bp->p ){
				inf_update( bp->val[SP_Y], &Ibgp.val[SP_Y] );
				inf_update( bp->val[SP_Q], &Ibgp.val[SP_Q] );
				inf_update( bp->val[SP_A], &Ibgp.val[SP_A] );
				Ibgp_no++;
			}
		}
}

 

void
inf_bgp_print( FILE *fp )
{

	fprintf (fp, "\n\n\nBG: %d\n", Ibgp_no );
	fprintf (fp, "---------------\n\n" );

	fprintf (fp, "\n" );
	inf_print( fp, "Val -  Y", &Ibgp.val[SP_Y], 1.0 );
	inf_print( fp, "Val -  Q", &Ibgp.val[SP_Q], 1.0 );
	inf_print( fp, "Val -  A", &Ibgp.val[SP_A], 1.0 );
}
