/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	"InfIn.h"
#include        "Uigp/igp.h"



static int Edge_no,	Pno;

static struct INF_Edge {
	inf	interval;
	inf	width;

	inf	len;

	inf	rval[SP_NO];
	inf	lval[SP_NO];

	inf	rpval,	lpval;
}       Iedge;

static int W[10000];

void
inf_edge_init()
{
int	sp;

	Edge_no = Pno = 0;

	Iedge.interval = Inf_init;
	Iedge.width = Inf_init;

	Iedge.len = Inf_init;

	for (sp = 0; sp < SP_NO; sp++) {
		Iedge.rval[sp] = Inf_init;
		Iedge.lval[sp] = Inf_init;

	}

	Iedge.rpval = Iedge.lpval = Inf_init;

}




void
inf_edge( vec2d *ctr, link_type *link )
{
int	i,	ino,	k,	pr_no;
float   t;
link_type	*l;
edge_type *edge;

	Edge_no++;

	for( l = link, ino = 0 ; l != NULL ; l = LINK_NEXT(l), ino++ ){

		inf_update( l->len, &Iedge.len );

		pr_no = ( LINK_NEXT(l) == NULL )? 2 : 1;
		for( i = 0 ; i < pr_no ; i++ ){
			Pno++;


			edge = l->pr[i].edge;


			inf_update( edge->width, &Iedge.width);
			k = edge->width * 100 + 0.5;
			if (k < 10000)	W[k]++;



			inf_update(edge->side[F_RIGHT].val[SP_Y],
							&Iedge.rval[SP_Y]);
			inf_update(edge->side[F_LEFT].val[SP_Y],
							&Iedge.lval[SP_Y]);


			inf_update(edge->side[F_RIGHT].val[SP_Q],
							&Iedge.rval[SP_Q]);
			inf_update(edge->side[F_LEFT].val[SP_Q],
							&Iedge.lval[SP_Q]);


			inf_update(edge->side[F_RIGHT].val[SP_A],
							&Iedge.rval[SP_A]);
			inf_update(edge->side[F_LEFT].val[SP_A],
							&Iedge.lval[SP_A]);

			t = -edge->side[F_RIGHT].val[SP_Y] +
						edge->side[F_RIGHT].bval[SP_Y];
			inf_update( t, &Iedge.rpval );
			t = edge->side[F_LEFT].val[SP_Y] -
						edge->side[F_LEFT].bval[SP_Y];
			inf_update( t, &Iedge.lpval );
		}
	}
		

	inf_update((float) ino, &Iedge.interval);
}




void
inf_edge_print(FILE * fp)
{
int	sp;

	fprintf(fp, "\n\nEdge: %d    Profile: %d\n", Edge_no, Pno );
	fprintf(fp, "---------------\n\n");

	inf_print(fp, "Link", &Iedge.interval, 1.0);

	fprintf(fp, "\n");
	inf_print(fp, "Link-len", &Iedge.len, 1.0);
	inf_print(fp, "Width", &Iedge.width, 1.0);

	inf_print(fp, "R-pval  ", &Iedge.rpval, 1.0);
	inf_print(fp, "L-pval  ", &Iedge.lpval, 1.0);

	for (sp = 0; sp < SP_NO; sp++) {

		fprintf(fp, "\nColor- %d\n", sp);

		inf_print(fp, "R-val  ", &Iedge.rval[sp], 1.0);

		inf_print(fp, "L-val  ", &Iedge.lval[sp], 1.0);

	}
}

void
inf_edge_print_total(FILE * fp)
{
float	w, inf_edge_max_width(int w[10000]);

	w = inf_edge_max_width(W);

	fprintf(fp, "Edge  :  %d         wdith: %.4f\n", Edge_no, w);
}



float
inf_edge_max_width(int w[10000])
{
int     i, s;
int	maxi, maxs;

	for (i = 0, s = 0; i < 25; i++)
		s += w[i];

	maxs = s;
	maxi = 12;
	for (i = 13; i + 12 < 10000; i++) {
		s += w[i + 12] - w[i - 13];
		if (s <= maxs)
			continue;

		maxs = s;
		maxi = i;
	}

	return (maxi / 100.0);
}
