/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef _INF_IN_

#define _INF_IN_

#define D2B_STEP        0.5 
#define D2B_LEVELS      8


#include	<float.h>

#include	"Uinf/uinf.h"

#include	"Inf.h"

#include	"GpType/GpType.h"


	/*  InfJnt.c */

void	inf_jnt_init();

void	inf_jnt( jnt_type *jnt, vec2d *v );

void	inf_jnt_print( FILE *fp );


	/* InfBgp.c */

void	inf_bgp_init();

void	inf_bgp( gp_array *agp );

void	inf_bgp_print( FILE *fp );


	/* InfProfile.c */

void	inf_profile_init();

void	inf_profile( link_type *link, int type, int side );

void	inf_profile_print ( FILE *fp );


	/*  InfEdge.c */

void	inf_edge_init();

void	inf_edge( vec2d *ctr, link_type *link );

void	inf_edge_print ( FILE *fp );

void	inf_edge_print_total( FILE *fp );



	/* InfN3.c  */

void	inf_n3_init();

void	inf_n3( vec2d *ctr, link_type *link );

void	inf_n3_print ( FILE *fp );

void	inf_n3_print_total( FILE *fp );



	/* InfRidge.c  */

void	inf_ridge_init();

void	inf_ridge( vec2d *ctr, link_type *link );

void	inf_ridge_print ( FILE *fp );

void	inf_ridge_print_total( FILE *fp );




	/* inf_hunch.c */

void	inf_hunch_init();

void	inf_hunch( hunch_type *h );

void	inf_hunch_print ( FILE *fp );

void	inf_hunch_print_total( FILE *fp );



	/* inf_rhunch.c */

void	inf_rhunch_init();
 
void	inf_rhunch( hunch_type *h );
 
void	inf_rhunch_print ( FILE *fp );

void	inf_rhunch_print_total( FILE *fp );
 
 

 		
#endif /* #ifndef _INF_IN_ */
