/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	"InfIn.h"
#include	"Uigp/igp.h"




static int	RHno;

struct INF_RHUNCH {
	inf	no;
	inf	angle;
        inf     len;

	inf	gval[SP_NO];
	inf	bval[SP_NO];

	inf	bvalQA;
}	Irh;

void
inf_rhunch_init()
{
int	i;

	RHno = 0;

	Irh.angle = Inf_init;
        Irh.len = Inf_init;

	for( i = 0 ; i < SP_NO ; i++ ){
		Irh.gval[i] = Inf_init;
		Irh.bval[i] = Inf_init;
	}

	Irh.bvalQA = Inf_init;

}


void
inf_rhunch( hunch_type *h )
{
int	i;

	RHno++;

       	inf_update( h->g.theta, &Irh.angle);   
        inf_update( h->g.len, &Irh.len );


	for( i = 0 ; i < SP_NO ; i++ ){
		inf_update( h->gval[i], &Irh.gval[i] );
		inf_update( h->rval[i], &Irh.bval[i] );
	}

        if( ABS(h->rval[SP_Q] ) > ABS(h->rval[SP_A]) )
                inf_update( h->rval[SP_Q], &Irh.bvalQA );
        else    inf_update( h->rval[SP_A], &Irh.bvalQA );

}	


void
inf_rhunch_print( FILE *fp )
{
int	sp;
	fprintf( fp, "\n\nRHunch: %d\n", RHno );
	fprintf( fp, "---------------\n");


	inf_print( fp, "Angle", &Irh.angle, 1.0 );
        inf_print( fp, "len", &Irh.len, 1.0 );

	for( sp = 0 ; sp < SP_NO ; sp++ ){

		fprintf( fp, "\nColor- %d\n", sp );

		inf_print( fp, "Gval  ", &Irh.gval[sp], 1.0 );

		inf_print( fp, "Rval  ", &Irh.bval[sp], 1.0 );
	}

	inf_print( fp, "\nRval QA", &Irh.bvalQA, 1.0 );
}


void
inf_rhunch_print_total( FILE *fp )
{ 
	fprintf( fp, "RHunch:  %d\n", RHno );
}
