/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***************************
 ***   AgpCopyBranch.c   ***
 ***************************/

#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"



#include	"LinkTool.h"



static void	polylink_inside_pointX( vec2d *ctr, link_type *link, box2d *b, vec2d *p );

static void	polylink_inside_pointY( vec2d *ctr, link_type *link, box2d *b, vec2d *p );


void
polylink_inside_point( vec2d *ctr, link_type *link, vec2d *p )
{
box2d	box;

	polylink_box( ctr, link, NULL, &box );


	box.x0 -= 2;
	box.x1 += 2;

	box.y0 -= 2;
	box.y1 += 2;


	if( box.x1 - box.x0 > box.y1 - box.y1 )
			polylink_inside_pointX( ctr, link, &box, p );
	else	polylink_inside_pointY( ctr, link, &box, p );
}



static void
polylink_inside_pointX( vec2d *ctr, link_type *link, box2d *b, vec2d *p )
{
vec2d	v;
float	u0,	t0,	gt0,	len,	u;
link_type	*sl0;
int	flag;


	v.x = 0.5 * ( b->x0 + b->x1 );


	flag = -1;

	for( v.y = b->y0-2 ; v.y < b->y1+2 ; v.y += 0.25 ){

		len = polylink_distance( ctr, link, NULL, &v, &sl0, &u0, &t0, &gt0 );
		if( ABS(u0) > 2.0 )	continue;


		if( flag == -1 ){
			flag = u0 > 0;
			u = u0;
			continue;
		}

		if( flag == (u0 > 0 ) ){
			u = u0;
			continue;
		}

		u = u0 ;

		*p = v;
		for( ; v.y < b->y1+2 ; v.y += 0.25 ){
			len = polylink_distance( ctr, link, NULL, &v, &sl0, &u0, &t0, &gt0 );

			if( ABS(u) > ABS(u0) )	return;


			p->y = v.y;
			u = u0;

			if( ABS(u) > 4 )	return;
		}
	}
}



static void
polylink_inside_pointY( vec2d *ctr, link_type *link, box2d *b, vec2d *p )
{
vec2d	v;
float	u0,	t0,	gt0,	len,	u;
link_type	*sl0;
int	flag;


	v.y = 0.5 * ( b->x0 + b->x1 );


	flag = -1;

	for( v.x = b->x0-2 ; v.x < b->x1+2 ; v.x += 0.25 ){

		len = polylink_distance( ctr, link, NULL, &v, &sl0, &u0, &t0, &gt0 );
		if( ABS(u0) > 2.0 )	continue;


		if( flag == -1 ){
			flag = u0 > 0;
			u = u0;
			continue;
		}

		if( flag == (u0 > 0 ) ){
			u = u0;
			continue;
		}


		*p = v;
		for( ; v.x < b->y1+2 ; v.x += 0.25 ){
			len = polylink_distance( ctr, link, NULL, &v, &sl0, &u0, &t0, &gt0 );

			if( ABS(u) > ABS(u0) )	return;


			p->x = v.x;
			u = u0;

			if( ABS(u) > 4 )	return;
		}
	}
}