/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/******************************** 
 ***    LinkReapproximate.c   ***
 ********************************/
#include	<stdio.h>
#include	<math.h>

#include	"Uigp/igp.h"

#include	"GpType/GpType.h"

#include	"AgpEdit/AgpEditTool.h"

#include	"LinkTool.h"







link_type * 
polylink_reapproximate( vec2d *ctr,link_type *link, link_type *elink, link_type **last )
{
gapp_prm	Qgprm;
gapp_type *gapp;
link_type *l,	*l1;



	Qgprm.dwight = 0.10F;
	Qgprm.err = 0.01F;

	Qgprm.min_len = 3.0F;
	Qgprm.Min_pnumber = 16;
	Qgprm.max_len = 16.0F;

	Qgprm.Max_dev = 1.0F;
	Qgprm.Min_dev = 0.1F;



	gapp = polylink_to_gapp( ctr, link, elink );

	geo_approximate( gapp, &Qgprm );

	
	l = link_from_gapp( gapp, 0, last );

	
	l->ctr = gapp->v[0];

	gapp_destroy( gapp );


	if( last != NULL ){
		for( l1 = l ; LINK_NEXT(l1) ; l1 = LINK_NEXT(l1) );
		*last = l1;
	}

	return( l );
}






gapp_type *
polylink_to_gapp( vec2d *ctr, link_type *link, link_type *elink )
{
link_type	*l;
vec2d	v;
float	t;
gapp_type	*gapp;
float	len;

	len = polylink_length( link, elink );
	gapp = gapp_alloc( (int)(len *4 + 100) );

	gapp->no = 0;


	link_t2xy( ctr, link, 0, &gapp->v[gapp->no] );
	link_tanget( link, 0, &gapp->tang[gapp->no] );

	gapp->flag[gapp->no] = 0;

	gapp->no++;



	for( l = link, v = *ctr ;  ; l = LINK_NEXT(l) ){
		
		for( t = 0.125 ; t < l->len ; t += 0.25 ){
			link_t2xy( &v, l, t, &gapp->v[gapp->no] );
			link_tanget( l, t, &gapp->tang[gapp->no] );

			gapp->flag[gapp->no] = 0;

			gapp->no++;
		}


		if( t - l->len < 0.1 ){
			t -= 0.125;
			link_t2xy( &v, l, t, &gapp->v[gapp->no] );
			link_tanget( l, t, &gapp->tang[gapp->no] );

			gapp->flag[gapp->no] = 0;

			gapp->no++;
		}

		if( l == elink || LINK_NEXT(l) == NULL  )	break;

		v.x += l->v.x;
		v.y += l->v.y;

	}


	link_t2xy( &v, l, l->len, &gapp->v[gapp->no] );
	link_tanget( l, l->len, &gapp->tang[gapp->no] );

	gapp->flag[gapp->no] = 0;

	gapp->no++;

	return( gapp );
}
