/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	LinkSetProfile.c ***
 **************************/

#include	<math.h>
#include	"ImageType/ImageType.h"



#include "LinkTool.h"



#define		RGB_SET( RY, GCr,BCb, color ) \
			{ \
				RY = IMAGE4_RED(color); \
				GCr = IMAGE4_GREEN(color); \
				BCb = IMAGE4_BLUE(color); \
			}

static void	color_set( qcolor_type c[SP_NO], int color );


static void	agp_Rgb_edge( edge_type *e, int rrcolor, int lcolor );



void
link_profile_alloc( link_type *link, int type )
{
link_type *l,	*pl;

	for( l = link, pl = NULL ; l!=NULL ; pl = l, l=LINK_NEXT(l)){
		l->type = type;

		l->pr[0] = profile_alloc( type );
		if( pl != NULL )
			pl->pr[1] = l->pr[0];

		if( type == NF_N3 ){
			l->width[0] = width_alloc();
			if( pl != NULL )	pl->width[1] = l->width[0];
		}
	}


	pl->pr[1] = profile_alloc( type );

	if( type == NF_N3 )
		pl->width[1] = width_alloc();
}



void link_edge_set_profile( link_type *link, int br, int Fbr, float depth, float width, int color )
{
link_type *l;

	for( l=link ; l!=NULL ; l=LINK_NEXT(l)){

		l->br = br;
		l->Fbr=Fbr;


		l->pr[F_BEGIN].edge->depth = depth;
		l->pr[F_END].edge->depth = depth;

		l->pr[F_BEGIN].edge->width=width;
		l->pr[F_END].edge->width=width;			
		agp_Rgb_edge(l->pr[F_END].edge, color, 0 );
		agp_Rgb_edge(l->pr[F_BEGIN].edge, color, 0 );
	}
}



static void
agp_Rgb_edge( edge_type *e, int rcolor, int lcolor )
{
	color_set( e->side[F_RIGHT].val, rcolor );

	color_set( e->side[F_RIGHT].bval, rcolor );


	color_set( e->side[F_LEFT].val, lcolor );

	color_set( e->side[F_LEFT].bval, lcolor );
}


static void
color_set( qcolor_type c[SP_NO], int color )
{
int	r,	g,	b;

	r = IMAGE4_RED(color);
	g = IMAGE4_GREEN(color);
	b = IMAGE4_BLUE(color);

	c[SP_R] = F2QCOLOR( r );
	c[SP_G] = F2QCOLOR( g );
	c[SP_B] = F2QCOLOR( b );
}