/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

#include	"Uigp/igp.h"

#include	"GpType/GpType.h"


void
link_replace( link_type *link0, link_type *link1, link_type *l0, link_type *l1 )
{
link_type	*l;
jnt_type	*jnt;
int	bno;
in_type	*in,	*p;;

	l0->p[F_BEGIN] = link0->p[F_BEGIN];
	if( (l = LINK_PREV(l0) ) == NULL ){
		jnt = l0->p[F_BEGIN].p.jnt;
		bno = l0->p[F_BEGIN].bno;
		jnt->brn[bno]->link = l0;
	}
	else	{
		l->p[F_END].p.l = l0;
		l->pr[1] = l0->pr[0];
		l->width[1] = l0->width[0];
	}


	l1->p[F_END] = link1->p[F_END];
	if( (l = LINK_NEXT(l1) ) == NULL ){
		jnt = l1->p[F_END].p.jnt;
		bno = l1->p[F_END].bno;
		jnt->brn[bno]->link = l1;
	}
	else	{
		l->p[F_BEGIN].p.l = l1;
		free( l1->pr[1].p );
		l1->pr[1] = l->pr[0];
		if( l1->width[1] != NULL ){
			free( l1->width[1] );
			l1->width[1] = l->width[0];
		}
	}



	if( l0->type != NF_N3 && l0->type != NF_N3R )	return;

	for( l = link0 ; l != NULL ; l = LINK_NEXT(l) ){

		for( in = l->in[F_RIGHT] ; in != NULL ; ){
			p = in;
			in = in->p;
			jnt = p->jnt;
			bno = p->bno;

			jnt->brn[bno]->in = NULL;
			free( p );

			jnt->brn[bno]->link = l0;
			jnt_n3_in_set( jnt, bno );
		}
		l->in[F_RIGHT] = NULL;
			
		for( in = l->in[F_LEFT] ; in != NULL ; ){
			p = in;
			in = in->p;
			jnt = p->jnt;
			bno = p->bno;

			jnt->brn[bno]->in = NULL;
			free( p );

			jnt->brn[bno]->link = l0;
			jnt_n3_in_set( jnt, bno );
		}
		l->in[F_LEFT] = NULL;



		if( l == link1 )	break;
	}
}




void
link_2_free( gp_array *agp, vec2d *ctr, link_type *l0, link_type *l1 )
{
link_type	*l,	*pl;
vec2d	v;

        for( l = l0, v = *ctr ; l != NULL ; ){
		
		agp_untied_link( agp, &v, l );

                v.x += l->v.x;
                v.y += l->v.y;

		pl = l;
		l = LINK_NEXT(l);
		link_1_free( pl  );

		if( pl == l1 )	break;
	}
}
