/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************
 ***	RlCorner.c   ***
 ***********************/

#include        <stdio.h>   
#include	<math.h>

#include        "Uigp/igp.h"
#include        "Uprm/prm.h"

#include        "GpType/GpType.h"


#include	"UGeoApp/GeoApp.h"

#include        "RlType.h"



static gapp_prm	Cgprm;
float	Cang = 0.95f;
float	Clen_d = 1.0f;

static GP_prm params[]  = {
	{"C-ang" , (char *)&Cang,PRM_FLOAT,"%.4f","0.95"},
	{"C-len-d" , (char *)&Clen_d,PRM_FLOAT,"%.4f","1.00"},
};


void
rl_link_corner_get_prm(GP_prm **prm, int *prm_no, void (**check)() )
{
	*prm    = params;
	*prm_no  = PRM_NUMBER(params);
	*check = NULL ;
}


void
rl_link_corner_set_lprm()
{
}


void
rl_link_corner( rl_aux laux[], int lno, gapp_type *gapp )
{
link_type	*l,	*nl;
float	tmp;
int	i;

	laux[0].type = RL_CORNER;

	l = laux[0].link;

	for( i = 1 ; i < lno ; i++ ){
		nl = laux[i].link;

		tmp = l->u.x * nl->u.x + l->u.y * nl->u.y;

		laux[i].type = ( ABS(tmp) < Cang)? RL_CORNER : RL_NULL;

		l = nl;
	}

	if( laux[0].link->len < Clen_d )	laux[1].type = RL_NULL;
	if( laux[lno-1].link->len < Clen_d )	laux[lno-1].type = RL_NULL;

	laux[lno].type = RL_CORNER;
}
