/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************************************************************/

/*                            RlGapp.c				*/ 

/************************************************************************/
#include        <stdio.h>   
#include	<math.h>

#include        "Uigp/igp.h"
#include        "Uprm/prm.h"

#include        "GpType/GpType.h"


#include	"UGeoApp/GeoApp.h"

#include        "RlType.h"



void
rl_link_gapp( vec2d *ctr, link_type *link, link_type *elink,
			gapp_type *gapp, rl_aux laux[], int *lno )
{
link_type	*l;
vec2d	v;
float	t;

	gapp->no = 0;

	for( l = link, v = *ctr, *lno = 0 ; l != NULL ;
					l = LINK_NEXT(l), (*lno)++ ){
		laux[*lno].ctr = v;
		laux[*lno].link = l;
		laux[*lno].i0 = gapp->no;
		


		for( t = 0.25 ; t < l->len ; t += 0.5 ){
			link_t2xy( &v, l, t, &gapp->v[gapp->no] );
			link_tanget( l, t, &gapp->tang[gapp->no] );

			gapp->flag[gapp->no] = 0;

			gapp->no++;
		}

		if( t - l->len < 0.2 ){
			t -= 0.25;
			link_t2xy( &v, l, t, &gapp->v[gapp->no] );
			link_tanget( l, t, &gapp->tang[gapp->no] );

			gapp->flag[gapp->no] = 0;

			gapp->no++;
		}

		laux[*lno].i1 = gapp->no;

		v.x += l->v.x;
		v.y += l->v.y;
		if( l == elink )	break;
	}

	if( elink != NULL )	(*lno)++;
	laux[*lno].ctr = v;
	laux[*lno].i0 = gapp->no;
}
