/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************
 ***	RlLink.c   ***
 *********************/
#include        <stdio.h>   
#include	<math.h>

#include        "Uigp/igp.h"
#include        "Uprm/prm.h"

#include        "GpType/GpType.h"
#include        "AgpEdit/AgpEditTool.h"


#include	"UGeoApp/GeoApp.h"

#include        "RlType.h"
#include        "RlType2.h"

void
rl_link_agp_2( gp_array *agp )
{
gp_type	*gp;
jnt_type	*jnt;
brn_type	*b;
int	i,	j,	k;

	if( Frl == 0 )	return;


/*
	agp_link_in_aux_clear( agp );
*/

	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){

			for( k = 0 ; k < jnt->brn_no ; k++ ){
				b = jnt->brn[k];
				if( b->direction != F_BEGIN )	continue;
				if( b->type != BRN_EDGE && b->type != BRN_RIDGE)
					continue;

				rl_link_brn_2( jnt, k, agp );
			}
		}
	    }


	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){

			for( k = 0 ; k < jnt->brn_no ; k++ ){
				b = jnt->brn[k];
				if( b->direction != F_BEGIN )	continue;
				if( b->type != BRN_N3 && b->type != BRN_N3R )
					continue;

				rl_link_brn_2( jnt, k, agp );
			}
		}
	    }



	for( i = 0 ; i < agp->Ni ; i++ )
	    for( j = 0 ; j < agp->Nj ; j++ ){
		gp = &agp->gp[i][j];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
			if( jnt->type != JNT_N3 )	continue;

			agp_jnt_n3_reposition( agp, jnt );
		}
	    }
}


void
rl_link_brn_2( jnt_type *jnt, int bno, gp_array *agp )
{
brn_type	*b;
gapp_type       *gapp;
rl_aux	laux[600];
int	lno;
rl_type	*rl = &Rl;
link_type	*l0,	*l1;
int	i,	j,	k;
vec2d	ctr;

	b = jnt->brn[bno];

	ctr.x = jnt->gctr.x + b->ctr.x;
	ctr.y = jnt->gctr.y + b->ctr.y;

	agp_lnf_clear_link( &ctr, b->link, agp );

	gapp = gapp_alloc( 4096 );
	rl_link_gapp( &ctr, b->link, NULL, gapp, laux, &lno );
	rl_link_corner_arc( laux, lno, gapp );

        for( i = 0; i < lno ;  ){
                for( j = i+1 ; laux[j].type != RL_CORNER ; j++ );

		if( j == i+1 && laux[i].link->len <= Qgprm.max_len ){
			i = j;
			continue;
		}
 
		gapp->ino = 0;

		rl_approximate_2( gapp, laux[i].i0, laux[j].i0-1,
			&laux[i].ctr, &laux[j].ctr, &Qgprm, rl );

		rl_to_link( laux[i].link->type, rl, laux, gapp->ino, &l0, &l1 );

		link_replace( laux[i].link, laux[j-1].link, l0, l1 );

		for( k = i ; k < j ; k++ )
			link_1_free( laux[k].link );

 
                i = j;
        }

	agp_lnf_link( &ctr, b->link, agp );

	jnt_load_nf_end_link( b->link );

	if( b->type == BRN_N3 )
		link_width_bes( b->link );

	gapp_destroy( gapp );
}

