/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_CODING_H_
#define		_CODING_H_

#include	"Uprm/prm.h"

#include	"CodingAdepth.h"

#include	"CodingHunch.h"
#include	"CodingLink.h"
#include	"CodingJoint.h"
#include	"CodingN3.h"
#include	"CodingBg.h"
#include	"CodingRidge.h"
#include	"CodingProfile.h"
#include	"CodingCenter.h"
#include	"CodingDepth.h"


typedef struct coding_type {

	int	head;
	int	N;

	codingAdepth_type	*ad;

	codingJoint_type	*jc;
	codingLink_type		*lc;
	codingN3_type		*nc;
	codingHunch_type	*hc;
	codingBg_type		*bc;
	codingProfile_type	*pc;
	codingRidge_type	*rc;
	codingCenter_type	*cc;

	codingDepth_type	*depth;

}	coding_type;





	/* for agp header */
#define	CODING_RH		0x01
#define	CODING_HUNCH		0x02
#define	CODING_RIDGE		0x04
#define	CODING_DEPTH		0x08
#define	CODING_DEPTH_DELTA	0x10
#define	CODING_LAYER_NAME	0x20





void	coding_get_group( GP_prm_group **prm_group, int *prm_group_no );

void	coding_set_config_dir( char *config_dir );

coding_type *	coding_init( int Lcoding, int bgp );

coding_type *	coding_set_local_prm( char *file, int bgp );

coding_type *	coding_set( int Lcoding, int bgp );


void		coding_free( coding_type * cprm );



 
#endif

