/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/*****************************
 ***	CodingBgBorder.c   ***
 *****************************/
#include        <stdio.h>   

#include        "GpType/GpType.h"

#include	"CodingBg.h"





static void	coding_bg_border_jnt( jnt_type *jnt );


void
coding_bg_border( gp_array *agp )
{
gp_type	*gp;
jnt_type	*jnt;

int	i,	j;

	for( i = 0 ; i < agp->Ni ; i++ ){
		gp = &agp->gp[i][0];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
			if( jnt->type == JNT_EDGE  || jnt->type == JNT_N3_P )
				coding_bg_border_jnt( jnt );
		}
	}


	for( i = 0 ; i < agp->Ni ; i++ ){
		gp = &agp->gp[i][agp->Nj-1];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
			if( jnt->type == JNT_EDGE  || jnt->type == JNT_N3_P )
				coding_bg_border_jnt( jnt );
		}
	}


	for( j = 1 ; j < agp->Nj-1 ; j++ ){
		gp = &agp->gp[0][j];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){
			if( jnt->type == JNT_EDGE  || jnt->type == JNT_N3_P )
				coding_bg_border_jnt( jnt );
		}
	}


	for( j = 1 ; j < agp->Nj-1 ; j++ ){
		gp = &agp->gp[agp->Ni-1][j];

		for( jnt = gp->jnt ; jnt != NULL ; jnt = jnt->nj ){

			if( jnt->type == JNT_EDGE  || jnt->type == JNT_N3_P )
				coding_bg_border_jnt( jnt );

		}
	}
}




static void
coding_bg_border_jnt( jnt_type *jnt )
{
brn_type	*b;
edge_type	*e,	*ne;
int	i;


	for( i = 0 ; i < jnt->brn_no ; i++ ){
		b = jnt->brn[i];

		if( b->direction == F_BEGIN ){
			e = b->link->pr[0].edge;
			ne = b->link->pr[1].edge;
		}
		else	{
			e = b->link->pr[1].edge;
			ne = b->link->pr[0].edge;
		}


		e->width = ne->width;


		e->side[F_RIGHT].bval[SP_Y ] = ne->side[F_RIGHT].bval[SP_Y ];
		e->side[F_LEFT].bval[SP_Y] = ne->side[F_LEFT].bval[SP_Y];

		e->side[F_RIGHT].val[SP_Y] = ne->side[F_RIGHT].val[SP_Y];
		e->side[F_LEFT].val[SP_Y] = ne->side[F_LEFT].val[SP_Y];


		e->side[F_RIGHT].bval[SP_Q] = ne->side[F_RIGHT].bval[SP_Q];
		e->side[F_LEFT].bval[SP_Q] = ne->side[F_LEFT].bval[SP_Q];

		e->side[F_RIGHT].val[SP_Q] = ne->side[F_RIGHT].val[SP_Q];
		e->side[F_LEFT].val[SP_Q] = ne->side[F_LEFT].val[SP_Q];


		e->side[F_RIGHT].bval[SP_A] = ne->side[F_RIGHT].bval[SP_A];
		e->side[F_LEFT].bval[SP_A] = ne->side[F_LEFT].bval[SP_A];

		e->side[F_RIGHT].val[SP_A] = ne->side[F_RIGHT].val[SP_A];
		e->side[F_LEFT].val[SP_A] = ne->side[F_LEFT].val[SP_A];
	}
}
