/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_CODING_BUFFER_
#define		_CODING_BUFFER_

#include        "Uigp/igp.h"

#include        "Ucode/code.h"





void	coding_buffer_initilaze_dir( char *dir, char *label );

void 	param_get_file_name( char *out_name, char *name, int sp );

void	coding_buffer_remove_dir();


	/* WRITE	*/
FILE *	coding_buffer_open_to_write( char *label, int sp );

void	coding_buffer_write ( FILE *fd,  void *buffer, int length );

void	coding_buffer_write_next( FILE *fd, char buffer );

#define CODING_BUFFER_WRITE_NEXT( fp, a )	( putc( a, fp ) )



	/* READ	*/
FILE *	coding_buffer_open_to_read( char *label, int sp );

void	coding_buffer_read( FILE *fd, void *buffer, int length );

int	coding_buffer_read_next( FILE *fd );

#define CODING_BUFFER_READ_NEXT( fp )	( (char)getc( fp ) )




	/* QUANTIAZE */
void 	param_zquantization( float *parray, char *buffer,
						code *pcod, int length );
void	param_quantization( float *parray, u_char *buffer,
						code *pcod, int length);

void	param_zreconstruction( float *parray, char *buffer,
						code *pcode, int plength); 

void	param_reconstruction( float *parray, u_char *buffer,
						code *pcode, int plength);


#endif
