/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include        <stdio.h>
#include        "Uigp/igp.h"
#include        "Ucode/code.h"

#include	"GpType/Configuration.h"

#include        "CodingCenter.h"







#ifndef PLAYER

code_in		Hctr_in = {-3.0, 3.0, 2.0,  0.0, 0.0 };
code_in		Pctr_in = {-3.0, 3.0, 1.0,  0.0, 0.0 };



static GP_prm  Params[]    =    {
        {"H-ctr-d",(char *)& Hctr_in.d, PRM_FLOAT, "%.3f", "2.0"},
        {"N-ctr-d",  (char *)& Pctr_in.d,PRM_FLOAT, "%.3f","1.0"},
};
	


void 
coding_center_get_prm( GP_prm  **prm, int *prm_no, void (**check)())
{
        *prm    = Params;
        *prm_no  = PRM_NUMBER(Params);
        *check = NULL;
}







codingCenter_type *
coding_center_set_lprm( char *file, int bgp )
{
codingCenter_type * cc;
float	hbgp;

	gp_prm_init( file, coding_center_get_prm );

	cc = ( (codingCenter_type *)malloc( sizeof( codingCenter_type ) ) ) ;

	hbgp = 0.5*bgp;


	code_set( &cc->Hctr, -hbgp, hbgp, Hctr_in.d, 0, 1.0 );
	code_set( &cc->Pctr, -hbgp, hbgp, Pctr_in.d, 0, 1.0 );


	cc->Cbst = NULL;

	return cc;
}
#endif


extern	float   H_ctr_d6[];
extern	float   N_ctr_d6[];
 
extern	float   H_ctr_d[];
extern	float   N_ctr_d[];


codingCenter_type *
coding_center_set( int iCoding, int bgp )
{
codingCenter_type * cc;
float	hbgp,	d;

	cc = ( (codingCenter_type *)malloc( sizeof( codingCenter_type ) ) ) ;

	hbgp = 0.5*bgp;


	d = ( bgp == 6)? H_ctr_d6[iCoding] : H_ctr_d[iCoding];
	code_set( &cc->Hctr, -hbgp, hbgp, d, 0, 1.0 );

	d = ( bgp == 6)? N_ctr_d6[iCoding] : N_ctr_d[iCoding];
	code_set( &cc->Pctr, -hbgp, hbgp, d, 0, 1.0 );


	cc->Cbst = NULL;

	return cc;
}

