/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	CodingDepth.c   ***
 **************************/
#include        "Uprm/prm.h"
#include 	"Ucode/code.h"

#include	"GpType/Configuration.h"

#include	"CodingDepth.h"




#ifndef PLAYER

static code_in Bdepth_in =      { 1.0, 127.0, 1.0, 0.0, 0.0 };
static code_in Depth_in =      { 1.0, 127.0, 1.0, 0.0, 0.0 };


static GP_prm  Param[]    =    {
	{"Bdepth-d", (char*)&Bdepth_in.d, PRM_FLOAT, "%.3f", "0.5"},
	{"Depth-d", (char*)&Depth_in.d, PRM_FLOAT, "%.5f", "0.5"},
};



void
coding_depth_get_prm( GP_prm  **prm, int *prm_no, void (**check)())
{
	*prm    = Param;
	*prm_no  = PRM_NUMBER(Param);
	*check = NULL;
}

 

	

codingDepth_type*
coding_depth_set_lprm( char *file )
{
codingDepth_type* dc;

	gp_prm_init( file, coding_depth_get_prm );

	dc = ( (codingDepth_type *)malloc( sizeof( codingDepth_type ) ) );

	code_set( &dc->Bdepth, 1.0, 127.0, Bdepth_in.d, 0, 1.0 );
	code_set( &dc->Depth, 1.0, 127.0, Depth_in.d, 0, 1.0 );

	return dc;
}
#endif




extern	float   Bdepth_d[];
extern	float   Depth_d[];


codingDepth_type*
coding_depth_set( int iCoding )
{
codingDepth_type* dc;
	dc = ( (codingDepth_type *)malloc( sizeof( codingDepth_type ) ) );

	code_set( &dc->Bdepth, 1.0, 127.0, Bdepth_d[iCoding], 0, 1.0 );
	code_set( &dc->Depth, 1.0, 127.0, Depth_d[iCoding], 0, 1.0 );

	return dc;
}