/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_CODING_LINK_
#define		_CODING_LINK_

#include	"Uprm/prm.h"
#include	"Ucode/code.h"

#include	"GpType/GpType.h"


typedef struct codingLink_type
{
	cfile_type	Lino_f;

	code	La;		/* Probola high */

	code    Llen;		/* Parrale projection */

	code	Lwidth;		/* Ortogonal projection */

	vec2d	Base_u;

}codingLink_type;



void	coding_link_get_prm( GP_prm **prm, int *prm_no, void (**check)());

codingLink_type	*	coding_link_set_lprm( char *file );

codingLink_type	*	coding_link_set( int iCoding, int bgp );

#endif
