/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

#include 	"Uigp/igp.h"
#include        "Uprm/prm.h"
#include 	"Ucode/code.h"

#include	"GpType/Configuration.h"

#include        "CodingN3.h"
#include <stdlib.h>






#ifndef PLAYER

static code_in Nwidth_in =      { -127.0, 127.0, 1.0, 0.0, 0.0 };



static GP_prm  Edge_params[]    =    {
	{"N-width-d", (char*)&Nwidth_in.d, PRM_FLOAT, "%.2f", "0.25"},
	{"N-width-a", (char*)&Nwidth_in.a, PRM_FLOAT, "%.2f", "0.0"},
};



void
coding_n3_get_prm( GP_prm  **prm, int *prm_no, void (**check)())
{
        *prm    = Edge_params;
        *prm_no  = PRM_NUMBER(Edge_params);
        *check = NULL;
}



codingN3_type *
coding_n3_set_lprm( char *file )
{
codingN3_type * nc =  ( (codingN3_type *)malloc( sizeof( codingN3_type ) ) ) ;

	gp_prm_init( file, coding_n3_get_prm );

	code_set( &nc->Nwidth, -127, 127, Nwidth_in.d, Nwidth_in.a, 1.0 );

	return nc;
}

#endif



extern float N_width_d[];
extern float N_width_a[];



codingN3_type *
coding_n3_set( int iCoding )
{
codingN3_type * nc =  ( (codingN3_type *)malloc( sizeof( codingN3_type ) ) ) ;

	code_set( &nc->Nwidth, -127, 127, N_width_d[iCoding], N_width_a[iCoding], 1.0 );

	return nc;
}

