/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	CodingRidge.c   ***
 **************************/
#include        "Uigp/igp.h"
#include        "Uprm/prm.h"

#include 	"Ucode/code.h"

#include	"GpType/Configuration.h"

#include 	"GpType/ColorType.h"

#include	"CodingRidge.h"

     

	

#ifndef PLAYER

static code_in Rval_in[SP_NO] =   {	{ -255.0, 255.0, 1.0 },
					{ -255.0, 255.0, 1.0 },
					{ -255.0, 255.0, 1.0 } };


static code_in Rlm_in =      { 5.0, 255.0, 4.0 };



static float   Rval_t;


static GP_prm  Params[]    =    {
	{"R-lm-d", (char*)&Rlm_in.d, PRM_FLOAT, "%.2f", "1.0"},

        {"R-val-Y-d", (char*)&Rval_in[SP_Y].d, PRM_FLOAT, "%.2f", "1.0"},
	{"R-val-Q-d", (char*)&Rval_in[SP_Q].d, PRM_FLOAT, "%.2f", "1.0"},
	{"R-val-A-d", (char*)&Rval_in[SP_A].d, PRM_FLOAT, "%.2f", "1.0"},

	{"R-val-t", (char*)&Rval_t, PRM_FLOAT, "%.2f", "3"},
};



void
coding_ridge_get_prm( GP_prm  **prm, int *prm_no, void (**check)())
{
        *prm    = Params;
        *prm_no  = PRM_NUMBER(Params);
        *check = NULL;
}






 

codingRidge_type *
coding_ridge_set_lprm( char *file )
{
codingRidge_type * rc = ((codingRidge_type *)malloc(sizeof(codingRidge_type))) ;

	gp_prm_init( file, coding_ridge_get_prm );

	code_set( &rc->Rlm, 5.0, 255.0, Rlm_in.d, 0, QCOLOR_UNIT );

	code_set( &rc->Rval[SP_Y], -255, 255.0, Rval_in[SP_Y].d, 0, QCOLOR_UNIT );
	code_set( &rc->Rval[SP_Q], -255, 255.0, Rval_in[SP_Q].d, 0, QCOLOR_UNIT );
	code_set( &rc->Rval[SP_A], -255, 255.0, Rval_in[SP_A].d, 0, QCOLOR_UNIT );


	rc->Rval_t = F2QCOLOR( Rval_t );

	return rc;
}

#endif




extern float	R_lm_d[];
extern float	R_val_Y_d[];
extern float	R_val_Q_d[];
extern float	R_val_A_d[];
extern float	R_val_t[];



codingRidge_type *
coding_ridge_set( int iCoding )
{
codingRidge_type * rc = ((codingRidge_type *)malloc(sizeof(codingRidge_type))) ;

	code_set( &rc->Rlm, 5.0, 255.0, R_lm_d[iCoding], 0, QCOLOR_UNIT );

	code_set( &rc->Rval[SP_Y], -255, 255.0, R_val_Y_d[iCoding], 0, QCOLOR_UNIT );
	code_set( &rc->Rval[SP_Q], -255, 255.0, R_val_Q_d[iCoding], 0, QCOLOR_UNIT );
	code_set( &rc->Rval[SP_A], -255, 255.0, R_val_A_d[iCoding], 0, QCOLOR_UNIT );


	rc->Rval_t = F2QCOLOR( R_val_t[iCoding] );

	return rc;
}