/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***   EncLayerBg.c   ***
 ************************/
#include        "Ucode/code.h"

#include		"Uigp/igp.h"

#include        "Encoding/EncIn.h"

#include        "EpType/EpType.h"
#include        "Ep2/Ep2Type.h"

#include		"Ep2/Ep2.h"

#include        "CodingBgIn.h"



#include        "Coding/CodingDepth.h"


/* declare in Coding/CodingDepth.h
 * cfile_type	Br_f;
 * cfile_type	Fbr_f;
 */



static void	encoding_layer_bg_trans0( ep2_array *aep2,
					int Abr[], int no, codingDepth_type *dc,bst_type *bst );

static void	encoding_layer_bg_trans1( ep2_array *aep2,
					int Abr[], int no,codingDepth_type *dc, bst_type *bst );


extern int	Lbits,	Lbr_no;


void
encoding_layer_bg( ep2_array *aep2,codingDepth_type *dc, bst_type *bst )
{
ep2_type	*ep2;
bound2_type	*b2;
int     i,      j,	k;
int	Abr[10],	mask,	no,	trans;


	aep2_br( aep2 );


	no = mask = trans = 0;
        for( i = 0 ; i < aep2->Ni ; i++ )
                for( j = 0 ; j < aep2->Nj ; j++ ){
			ep2 = &aep2->ep[i][j];

			for( k = 0 ; k < ep2->b_no ; k++ ){
				b2 = ep2->bound[k];
				if( b2->Sbr == 1 )	continue;

				if( b2->br == -1 ){
					trans++;
					continue;
				}

				if( mask & ( 1L<< b2->br) )	continue;
				mask |= 1L<< b2->br;

				Abr[no++] = b2->br;
			}
		}

	if( trans == 0 && no == 0 )	return;


	Lbits -= BST_BITS( bst );

	if( trans == 0 ){
		bst_put_int( bst, 0, 1 );
		encoding_layer_bg_trans0( aep2, Abr, no, dc,bst );
	}
	else	{
		bst_put_int( bst, 1, 1 );
		encoding_layer_bg_trans1( aep2, Abr, no,dc, bst );
	}



	Lbits += BST_BITS( bst );
}


static void
encoding_layer_bg_trans0( ep2_array *aep2, int Abr[], int no, codingDepth_type *dc,bst_type *bst )
{
ep2_type	*ep2;
bound2_type	*b2;
int	i,	j,	k;

	if( no == 1 ){
		bst_put_int( bst, 0, 1 );
		CODING_BUFFER_WRITE_NEXT( dc->Br_f.fp, Abr[0]  );
		Lbr_no++;

		return;
	}

	bst_put_int( bst, 1, 1 );

	for( i = 0 ; i < aep2->Ni ; i++ )
		for( j = 0 ; j < aep2->Nj ; j++ ){
			ep2 = &aep2->ep[i][j];
			for( k = 0 ; k < ep2->b_no ; k++ ){
				b2 = ep2->bound[k];
				if( b2->Sbr == 1 )	continue;


				CODING_BUFFER_WRITE_NEXT( dc->Br_f.fp, b2->br  );
				Lbr_no++;
			}
		}

}



static void
encoding_layer_bg_trans1( ep2_array *aep2, int Abr[], int no,codingDepth_type *dc, bst_type *bst )
{
ep2_type	*ep2;
bound2_type	*b2;
int	i,	j,	k;

	if( no == 0 ){
		bst_put_int( bst, 0, 1 );
		return;
	}
	bst_put_int( bst, 1, 1 );

	if( no == 1 ){
		bst_put_int( bst, 0, 1 );

		CODING_BUFFER_WRITE_NEXT( dc->Br_f.fp, Abr[0]  );
		Lbr_no++;
	}
	else	bst_put_int( bst, 1, 1 );

        for( i = 0 ; i < aep2->Ni ; i++ )
                for( j = 0 ; j < aep2->Nj ; j++ ){
			ep2 = &aep2->ep[i][j];

			for( k = 0 ; k < ep2->b_no ; k++ ){
				b2 = ep2->bound[k];

				if( b2->Sbr == 1 )	continue;

				if( b2->br == -1 ){
					bst_put_int( bst, 0, 1 );
					continue;
				}

				bst_put_int( bst, 1, 1 );

				if( no == 1 )	continue;


				CODING_BUFFER_WRITE_NEXT( dc->Br_f.fp, b2->br  );
				Lbr_no++;
			}
		}

}
