/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include        "Uigp/igp.h"
#include        "EncIn.h"

#include        "GpType/GpType.h"
#include        "EpType/EpType.h"
#include        "Ep2/Ep2.h"

#include	"EncIn.h"

#include        "EncBg.h"

#include	"Coding/CodingBg.h"




#define	BDVAL_FNAME_TEST	"bg_dTEST"

static FILE	*Bt_fp[SP_NO];


static int	Bdval_no;




void
encoding_bg_test_open( codingBg_type *bc)
{
int	sp;

	for (sp = 0; sp < SP_NO; sp++) {
		Bt_fp[sp] = coding_buffer_open_to_write(BDVAL_FNAME_TEST, sp);

		Bdval_no = 0;
	}
}




void
encoding_bg_test(ep_array * aep,codingBg_type *bc )
{
ep_type	*ep;
bound_type	*b;
int	i,	j,	k,cno;


	for( i = LSIZE ; i < aep->Ni - LSIZE ; i++ )
		for( j = LSIZE ; j < aep->Nj - LSIZE ; j++ ){

			ep = &aep->ep[i][j];

			for( k = 0 ; k < ep->b_no ; k++ ){
				b = ep->bound[k];
				if( b->Mbgp == NULL )	continue;

				cno = ZCODE( b->Mbgp->val[SP_Y], bc->Bdval[SP_Y] );
				CODING_BUFFER_WRITE_NEXT( Bt_fp[SP_Y], cno );

				cno = ZCODE( b->Mbgp->val[SP_Q], bc->Bdval[SP_Q] );
				CODING_BUFFER_WRITE_NEXT( Bt_fp[SP_Q], cno );

				cno = ZCODE( b->Mbgp->val[SP_A], bc->Bdval[SP_A] );
				CODING_BUFFER_WRITE_NEXT( Bt_fp[SP_A], cno );

				Bdval_no++;
			}
		}
}



void
encoding_bg_test_close(codingBg_type *bc)
{
int	sp;
	for (sp = 0; sp < SP_NO; sp++) {
		fclose(Bt_fp[sp]);
	}
}



static int Bdval_bits[SP_NO];


void
encoding_bg_test_huffman( codingBg_type *bc, FILE *cfd )
{
int	i, msg, cotype;
char	filename[256];

	gp_filename_get_temporary( "cod", 0, ".tmp", filename );

	cfd = fopen( filename,"wb" );

	for (i = 0; i < SP_NO; i++) {
		encoding_agp_file_append_huffman( cfd, BDVAL_FNAME_TEST, i,
					&msg, &Bdval_bits[i], &cotype);

	}

	fclose( cfd );

	unlink( filename );
}


void
encoding_bg_test_total_bits( int *fno, int *hbits )
{
	*hbits = Bdval_bits[SP_Y] + Bdval_bits[SP_Q] + Bdval_bits[SP_A];
	*fno = Bdval_no;
}
