/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_ENC_HUNCH_
#define		_ENC_HUNCH_


#include        "Ubst/BstType.h"
#include        "GpType/GpType.h"

#include        "Coding/CodingHunch.h"


void	encoding_hunch_open( codingHunch_type *hc );

void	encoding_hunch( hunch_type *ah[], int hunch_no,
					codingHunch_type *hc, bst_type *bst );

void	encoding_hunch_close( codingHunch_type *hc );

void	encoding_hunch_huffman( codingHunch_type *hc, FILE *cfd );

void	encoding_hunch_punch_line( FILE *fp );
void	encoding_hunch_end_line( FILE *fp );

int		encoding_hunch_print_inf( FILE *fp );


void	encoding_hunch_total_bits( int *fno, int *hbits );

#endif
