/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef ENCJOINT
#define ENCJOINT


#include        "Uprm/prm.h"
#include        "Ubst/BstType.h"
#include        "GpType/GpType.h"
#include        "Coding/CodingBuffer.h"
#include        "Coding/Coding.h"


void	encoding_joint_open(  codingJoint_type *jc );

void	encoding_joint( gp_array *agp,coding_type *cprm, bst_type *bst);

void    encoding_joint_close( codingJoint_type *jc );

void    encoding_joint_huffman(  codingJoint_type *jc, FILE *cfd);

void	encoding_joint_punch_line( FILE *fp );

void	encoding_joint_end_line( FILE *fp );

int	encoding_joint_print_inf( FILE *fp );



	/* EncBranchIn.c */
void	encoding_branch_in( gp_array *agp, jnt_type *jnt, int bno,
			codingJoint_type *jc, bst_type *bst );

#endif
