/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef		_ENC_LAYER_
#define		_ENC_LAYER_


#include        "GpType/GpType.h"
#include        "Ubst/BstType.h"

#include        "Ep2/Ep2Type.h"
#include        "Coding/Coding.h"

void	encoding_layer_open(codingDepth_type *dc);


int	encoding_layer( gp_array *agp, codingDepth_type *dc,bst_type *bst );

void	encoding_layer_bg( ep2_array *aep2,codingDepth_type *dc, bst_type *bst );


void	encoding_layer_close(codingDepth_type *dc);

void	encoding_layer_huffman( codingDepth_type *dc,FILE *cfd );

void	encoding_layer_punch_line( FILE *fp );

void	encoding_layer_end_line( FILE *fp );

int	encoding_layer_print_inf( FILE *fp );

#endif
