/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include	"Uigp/igp.h"

#include	"LossLessCoding.h"

#include	"Huffman.h"
#include	"Rlength.h"
#include	"Bits.h"



bst_type*
lossless_encoding( char *file, int *mbit, int *hbit, int *cotype )
{
char hfile[128];

cst_type* input, *cst_out;
bst_type* bst, *bst_temp;
int size, size_temp;

	sprintf (hfile,"%s.%s",file,"msg");
        *mbit = 8*gp_file_size (hfile);


	if( *mbit == 0 ){
		*cotype = 0x0e;

		*hbit = 0;

		unlink (hfile);

		return NULL;
	}

	input = cst_load_from_file( hfile );
	*cotype = 0;

	/* check the huffman code */
	bst = bst_temp = huffman_encoding_cst( input );
	size = size_temp = BST_BYTES( bst_temp );



	bst_temp = bitstream_encoding_cst( input );
	size_temp = BST_BYTES( bst_temp );

	if (size_temp < size) { 
		bst_free(bst);
		*cotype = 4;
		bst = bst_temp;
		size = size_temp;
	}
	else
		bst_free(bst_temp);



	bst_temp = huffman_encoding_extended_cst( input );
	size_temp = BST_BYTES( bst_temp );

	if (size_temp < size) { 
		bst_free(bst);
		*cotype = 5;
		bst = bst_temp;
		size = size_temp;
	}
	else
		bst_free(bst_temp);



	cst_out = rlength_encoding_cst(input, 1);
	bst_temp = huffman_encoding_cst( cst_out );
	cst_free(cst_out);
	size_temp = BST_BYTES( bst_temp );

	if ( size_temp < size ) {
		bst_free(bst);
		*cotype = 1;
		size = size_temp;
		bst = bst_temp;
	}
	else
		bst_free(bst_temp);

		

	*hbit = 8*size;
	cst_free(input);
	unlink (hfile);

	return bst;
}



