/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>

#include	"Uigp/igp.h"

#include	"Ucst/CstType.h"

#include	"Rlength.h"

void 
rlength_encoding(FILE *input, FILE *output, int a )
{
int     c, b, n;

	n = b = -1;
	while ((c = getc(input)) != EOF) {
		if (b != c) {
			if (n >= 0 )
				putc( n, output);

			b = n = -1;

			putc( c, output);
		}

		if (((c > 0) ? c : -c) < a && n < 256) {
			b = c;
			n++;
		}

		if (n == 255)
			b = -1;
	}

	if (n >= 0 )
		putc( n, output);
}

/*rlength_encoding_cst(cst_type *input, int a)*/
cst_type*
rlength_encoding_cst(cst_type *input, int a )
{
int     c, b, i, n;
cst_type *output;

	output = cst_alloc( rlength_estimate_cst(input, a ));
/*	output = cst_alloc( new_size);*/
	/*output = cst_alloc(input->byte_no * 2);*/
	cst_rewind( output );

	n = b = -1;
	for( i = 0 ; i < input->byte_no ; i++ ){
		c = CST_GET_UCHAR( input );
		if (b != c) {
			if (n >= 0 )
				CST_PUT_CHAR( output, n );
			b = n = -1;

			CST_PUT_CHAR( output, c);
		}

		if (((c > 0) ? c : -c) < a && n < 256) {
			b = c;
			n++;
		}

		if (n == 255)
			b = -1;
	}

	if (n >= 0 )
		CST_PUT_CHAR( output, n);

	cst_rewind(output);
	cst_rewind(input);
	return output;
}


unsigned long rlength_estimate(FILE *input, int a )
{
int     c, b, n, old_size = 0, new_size = 0;

	n = b = -1;
	while ((c = getc(input)) != EOF) {
		if (b != c) {
			if (n >= 0 )
				new_size++;

			b = n = -1;
			new_size++;
		}

		if (((c > 0) ? c : -c) < a && n < 256) {
			b = c;
			n++;
		}

		if (n == 255)
			b = -1;

		old_size++;
	}

	if (n >= 0 )
		new_size++;

	return new_size;
}


unsigned long rlength_estimate_cst(cst_type *input, int a )
{
int     c, b, n,i, new_size = 0;

	n = b = -1;
	for( i = 0 ; i < input->byte_no ; i++ ){
		c = CST_GET_UCHAR(input);
		if (b != c) {
			if (n >= 0 )
				new_size++;

			b = n = -1;
			new_size++;
		}

		if (((c > 0) ? c : -c) < a && n < 256) {
			b = c;
			n++;
		}

		if (n == 255)
			b = -1;
	}

	if (n >= 0 )
		new_size++;

	cst_rewind( input );
	return new_size;
}
