/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**********************
 *** Image4to1.c   ***
 **********************/
#include	"ImageType/ImageType.h"

image_type *
image_4to1( image_type *sim )
{
image_type *im;
u_char	*tp;
u_int	*sp;
int	r,	g,	b;
int	i,	j;

	im = image_create( sim->row, sim->column, 1, 1, NULL );

	sp = (u_int *)sim->data;
	tp = im->data;

	for( i = 0 ; i < im->row ; i++ )
		for( j = 0; j < im->column ; j++ ){

			r = IMAGE4_RED( *sp );
			g = IMAGE4_GREEN( *sp );
			b = IMAGE4_BLUE( *sp );
			sp++;
			
			r = r >> 6;
			g = g >> 6;
			b = b >> 6;
		
			*tp++ = (((r)<<4) | ((g)<<2) | (b) );
		}

	return( im );
}


image_type *
image_1to4( image_type *sim )
{
image_type *im;
u_int	*tp;
u_char	*sp;
int	r,	g,	b;
int	i,	j;

	im = image_create( sim->row, sim->column, 4, 1, NULL );

	sp = sim->data;
	tp = (u_int *)im->data;

	for( i = 0 ; i < im->row ; i++ )
		for( j = 0; j < im->column ; j++ ){

			r = ( ((*sp) >> 4 ) &0x3 );
			g = ( ((*sp) >> 2 ) &0x3 );
			b = ( (*sp) &0x3 );
			sp++;

			r = (r << 6) + 32;
			g = (g << 6) + 32;
			b = (b << 6) + 32;

			*tp++ = IMAGE4_RGB( r, g, b );
		}

	return( im );
}