/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***   ImageEqual.c   ***
 ************************/
#include	"ImageType/ImageType.h"


static int	image1_equal( image_type *im0, image_type *im1 );

static int	image8_equal( image_type *im0, image_type *im1 );


int
image_equal( image_type *im0, image_type *im1 )
{
int	i,	j;
u_int	*p0,	*p1;
int	n;

	if( im0->depth == 8 )
		return image8_equal( im0, im1 );

	if( im0->depth == 1 )
		return image1_equal( im0, im1 );


	p0 = (u_int *)im0->data;
	p1 = (u_int *)im1->data;

	n = 0;
	for( i = 0 ; i < im0->row ; i++ )
		for( j = 0 ; j < im0->column ; j++ ){
			if( *p0 != *p1 )
				n++;
			p0++;
			p1++;

		}

		return(n);
}



static int
image1_equal( image_type *im0, image_type *im1 )
{
int	i,	j;
u_char	*p0,	*p1;
int	n;

	if( im0->depth == 8 )
		return image8_equal( im0, im1 );

	if( im0->depth == 1 )
		return image1_equal( im0, im1 );


	p0 = (u_char *)im0->data;
	p1 = (u_char *)im1->data;

	n = 0;
	for( i = 0 ; i < im0->row ; i++ )
		for( j = 0 ; j < im0->column ; j++ ){
			if( *p0 != *p1 )
				n++;
			p0++;
			p1++;

		}

		return(n);
}


static int
image8_equal( image_type *im0, image_type *im1 )
{
int	i,	j;
float	*p0,	*p1;
int	n;
	p0 = (float *)im0->data;
	p1 = (float *)im1->data;

	n = 0;
	for( i = 0 ; i < im0->row ; i++ )
		for( j = 0 ; j < im0->column ; j++ ){
			if( *p0 != *p1 )
				n++;
			p0++;
			p1++;
			if( *p0 != *p1 )
				n++;
			p0++;
			p1++;
		}

		return(n);
}
