/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<malloc.h>

#include	"ImageType/ImageType.h"

static void 
image4_negative( image_type *im );

static void 
image1_negative( image_type *im );



void 
image_negative( image_type *im )
{
	if ( im->depth == 4 )
		image4_negative( im );
	else
		image1_negative( im );
}


static void 
image4_negative( image_type *im )
{
u_int	*dp;
int		row, col, i, j;

	row = IMAGE_ROW(im); 
	col = IMAGE_COLUMN(im); 

	dp = (u_int *)im->data;
	for( i = 0; i < row; i++ )
	for( j = 0; j < col; j++ )
		*dp++ =  0x00FFFFFF - (*dp);
}


static void 
image1_negative( image_type *im )
{
u_char	*dp;
int		row, col, i, j;

	row = IMAGE_ROW(im); 
	col = IMAGE_COLUMN(im); 

	dp = (u_char *)im->data;
	for( i = 0; i < row; i++ )
	for( j = 0; j < col; j++ )
		*dp++ = 0xFF - (*dp);
}


