/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<malloc.h>

#include	"ImageType/ImageType.h"


static image_type * 
image4_resize( image_type *imd, image_type *ims, int row, int col );

static image_type * 
image1_resize( image_type *imd, image_type *ims, int row, int col );



image_type * 
image_resize( image_type *imd, image_type *ims, int row, int col )
{
	if ( imd->depth == 4 )
		return image4_resize( imd, ims, row, col );
	else
		return image1_resize( imd, ims, row, col );
}


static image_type * 
image4_resize( image_type *imd, image_type *ims, int row, int col )
{
u_int	*p, *dp;
int		row_old, col_old;
int		i, j, is, js, shift;

	row_old = IMAGE_ROW(imd); 
	col_old = IMAGE_COLUMN(imd); 

	if ( ims == NULL )
		ims = image_create( row, col, 4, 1, NULL );
	dp = (u_int *)ims->data;
	for( i = 0; i < row; i++ )
	for( j = 0; j < col; j++ )
		*dp++ = 0x00FFFFFF;

	is = (row - row_old)/2;
	js = (col - col_old)/2;
	shift = col - col_old;

	p = (u_int *)imd->data;
	dp = (u_int *)ims->data + is*col +js;

	for( i = 0; i < row_old; i++ )
	{
		for( j = 0; j < col_old; j++ )
		{
			*dp = *p;
			p++;
			dp++;
		}
		dp += shift;
	}

	return( ims );	
}


static image_type * 
image1_resize( image_type *imd, image_type *ims, int row, int col )
{
u_char	*p, *dp;
int		row_old, col_old;
int		i, j, is, js, shift;

	row_old = IMAGE_ROW(imd); 
	col_old = IMAGE_COLUMN(imd); 

	if ( ims == NULL )
		ims = image_create( row, col, 1, 1, NULL );

	dp = (u_char *)ims->data;
	for( i = 0; i < row; i++ )
	for( j = 0; j < col; j++ )
		*dp++ = 0xFF;

	is = (row - row_old)/2;
	js = (col - col_old)/2;
	shift = col - col_old;

	p = (u_char *)imd->data;
	dp = (u_char *)ims->data + is*col +js;

	for( i = 0; i < row_old; i++ )
	{
		for( j = 0; j < col_old; j++ )
		{
			*dp = *p;
			p++;
			dp++;
		}
		dp += shift;
	}

	return( ims );	
}
