/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	BstTool.c	***
 **************************/
#include	<stdio.h>
#include	<malloc.h>
#include	<memory.h>

#include	"Uigp/igp.h"

#include	"GeoApp.h"


gapp_type *
gapp_alloc( int no )
{
gapp_type *gapp;

	gapp = (gapp_type *)malloc( sizeof(gapp_type) );

	gapp->N = no;

	gapp->v = (vec2d *) malloc( sizeof(gapp_type)*gapp->N );

	gapp->tang = (vec2d *) malloc( sizeof(gapp_type)*gapp->N );

	gapp->flag = (int *) malloc( sizeof(int)*gapp->N );

	gapp->a = (float *) malloc( sizeof(float)*gapp->N );

	return( gapp );

}


void
gapp_destroy( gapp_type *gapp )
{
	free( gapp->v );
	free( gapp->tang );
	free( gapp->flag );
	free( gapp->a );

	free( gapp );
}
