/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************************************************************/

/*                            d2gp_ridge.c				*/ 

/************************************************************************/
#include        <stdio.h>   
#include	<math.h>
#include	<malloc.h>


#include	"Uigp/igp.h"

#include	"GeoApp.h"
#include	"GelmType.h"


void
gelm_from_gapp( gapp_type *gapp, vec2d *ctr, gelm_type **gelm )
{
gelm_type	**g,	*l;
vec2d	p,	v;
int	i,	iseg,	cseg;
  
	*ctr = gapp->v[0];


	p = *ctr;
	
	for( i = 0, g = gelm, cseg = iseg = 0 ; i < gapp->ino; i++ ){

		iseg = gapp_next( gapp, iseg, GEOM_DIVISION);

		v = gapp->v[iseg];


		l = *g = GELM_ALLOC();
		g = &l->p[F_END];

		l->v.x = v.x - p.x;
		l->v.y = v.y - p.y;

		p.x += l->v.x;
		p.y += l->v.y;


		/* set AUX */
		if( l->v.x == 0.0 && l->v.y == 0 ){
			l->len = l->u.x = l->u.y = l->c_prb = l->a = 0.0;
			continue;
		}


		l->len = hypot( l->v.x, l->v.y );
 
		l->u.x = l->v.y/l->len;
		l->u.y = -l->v.x/l->len;

		l->c_prb = gapp->a[iseg];
		l->a = - l->c_prb * l->len * l->len * 0.25;
	}

	*g = NULL;
}


void
gelm_free( gelm_type *gelm )
{
gelm_type	*l,	*l1;

	for( l = gelm ; l != NULL ; ){
		l1 = l;
		l = l->p[F_END];
		free( l1 );
	}
}
