/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************************************************************/
/*									*/
/*           LinkType.h   	         				*/
/*									*/
/************************************************************************/

#ifndef         GELM_TYPE
#define         GELM_TYPE


#include	"Uvec/Vec2d.h"
#include	"GeoApp.h"



typedef struct gelm_type {

	vec2d	v;		/* len* ( cos(angle) , sin(angle) )	*/
	float	a;		/* maximal height of parabola */


/*	AUX	*/
	float	len;

	vec2d	u;		/* right normal to v	*/
	float   c_prb;		/* 2-nd order coefficient of parabola */



	struct gelm_type	*p[2];		/* F_BEGIN and F_END */
} gelm_type;




#define		GELM_ALLOC()	\
			( (gelm_type *)malloc( sizeof( gelm_type ) ) )


#define		GELM_NEXT( link )	( link->p[F_END] )

#define		GELM_PREV( link )	( link->p[F_BEGIN] )



gelm_type *	gelm_alloc( int ino );

void	gelm_free( gelm_type *gelm );

void	gelm_from_gapp( gapp_type *gapp, vec2d *ctr, gelm_type **gelm );

#endif
