/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	"ls_appr.h"
#include	"Uigp/igp.h"

float
get_parab_coef( vec2d v[],float tg[], float len, int no, float dw )
{
float	a,	ftemp,	dtemp;
float	fsum,	dsum;
int i;

	fsum = dsum = 0;

	for (i = 0 ; i < no; i++ ){
		ftemp = v[i].x * (v[i].x - len);

		dtemp = 2.0 * v[i].x - len;

		fsum += ftemp * ftemp + dw *dtemp * dtemp; 
		dsum += v[i].y * ftemp + dw * tg[i] * dtemp;
	}
	a = dsum/fsum;
	return( a );
}


float
get_l2_dist( vec2d v[], float tg[], float a, float len, int no, float dw )
{
float	tmp,	sum = 0.0;
int i;

	for( i = 0 ; i < no ; i++ ) {
		sum += (a * v[i].x * (v[i].x - len ) - v[i].y) * (a * v[i].x
			* (v[i].x - len ) - v[i].y);

		sum += dw * (a * (2.0 * v[i].x - len) - tg[i]) * (a * (2.0 *
			v[i].x - len) - tg[i]);
	}

	tmp = sum / no;
	return( tmp );
}


float
get_max_dist( vec2d *v, float *tg, float a, float len, int no )
{
int	i;
float	tmp,	dis = 0;

	for (i = 0 ; i < no ; i++ ){

		tmp = a * v[i].x * (v[i].x - len ) - v[i].y;
		if( tmp < 0 )	tmp = -tmp;

		if( tmp > dis )	dis = tmp;
	}

	return( dis );
}
