/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>


#include	"Uigp/igp.h"

#include	"Box2d.h"


int
box2i_select( box2i *b, int select_t, int x, int y )
{
int	tmp,	max,	op;

	op = 0;
	max = select_t;

	tmp = ( b->x0 - x )*( b->x0 - x ) + ( b->y0 - y )*( b->y0 - y );
	if( tmp < max ){
		max = tmp;
		op = 1;
	}

	tmp = ( b->x0 - x )*( b->x0 - x ) + ( b->y1 - y )*( b->y1 - y );
	if( tmp < max ){
		max = tmp;
		op = 2;
	}


	tmp = ( b->x1 - x )*( b->x1 - x ) + ( b->y0 - y )*( b->y0 - y );
	if( tmp < max ){
		max = tmp;
		op = 3;
	}

	tmp = ( b->x1 - x )*( b->x1 - x ) + ( b->y1 - y )*( b->y1 - y );
	if( tmp < max ){
		max = tmp;
		op = 4;
	}

	if( op != 0 )	return( op );

	return( 0 );
}
