/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<malloc.h>
#include	<string.h>

#include	"Uigp/igp.h"
#include	"CfgType.h"




cfg_type *
cfg_alloc()
{
cfg_type	*cfg;

	cfg = ( cfg_type *)malloc( sizeof( cfg_type) );

	cfg->pAttr = NULL;
	cfg->pCfg = NULL;
	cfg->next = NULL;

	return( cfg );
}




cfgAttr_type	*
cfgAttr_alloc()
{
cfgAttr_type	*a;

	a = ( cfgAttr_type *)malloc( sizeof( cfgAttr_type) );

	a->next = NULL;
	return( a );
}



cfg_type	*
cfg_get_container ( cfg_type *cfg, char *name )
{
cfg_type *a;

	for( a = cfg->pCfg ; a != NULL ; a = a->next )
		if( gp_stricmp( a->name, name ) == 0 )	return( a );

	return( NULL );
}

cfg_type	*
cfg_get_next_container ( cfg_type *cfg, char *name, cfg_type *pcfg )
{
cfg_type *a;

	
	for( a = (pcfg == NULL)? cfg->pCfg: pcfg->next ; a != NULL ; a = a->next )
		if( gp_stricmp( a->name, name ) == 0 )	return( a );

	return( NULL );
}

cfgAttr_type	*
cfg_get_attribute( cfg_type *cfg, char *name )
{
cfgAttr_type *a;

	for( a = cfg->pAttr ; a != NULL ; a = a->next )
		if( gp_stricmp( a->name, name ) == 0 )	return( a );

	return( NULL );
}




void
cfg_destroy( cfg_type *cfg )
{
cfgAttr_type	*a;
cfg_type	*c;

	while( (a = cfg->pAttr) != NULL ){
		cfg->pAttr = cfg->pAttr->next;
		free( a );
	}

	while( (c = cfg->pCfg) != NULL ){
		cfg->pCfg = cfg->pCfg->next;
		cfg_destroy( c );
	}

	free( cfg );
}



