/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef __CFG_TYPE__
#define __CFG_TYPE__

#ifdef __cplusplus
extern "C" {
#endif




#define	CFG_MAX_NAME	64
#define	CFG_MAX_DATA	256




typedef struct cfgAttr_type 
{
	char name[CFG_MAX_NAME];
	char data[CFG_MAX_DATA];


	struct cfgAttr_type	*next;

}	cfgAttr_type;




typedef struct cfg_type 
{
	char name[CFG_MAX_NAME];


	cfgAttr_type	*pAttr;

	struct cfg_type	*pCfg;


	struct cfg_type	*next;

}	cfg_type;



	/* CfgTool.c */
cfg_type *	cfg_alloc();

cfgAttr_type	*	cfgAttr_alloc();

void	cfg_destroy( cfg_type *cfg );


cfg_type	*	cfg_get_container ( cfg_type *cfg, char *name );
cfg_type	*	cfg_get_next_container ( cfg_type *cfg, char *name, cfg_type *pcfg );


cfgAttr_type	*	cfg_get_attribute( cfg_type *cfg, char *name );


	/* CfgParser.c */
cfg_type *	cfg_parser_file( char *file );

	/* CfgWrite.c */
int		cfg_write_file( cfg_type *cfg, char *file );



#ifdef __cplusplus
}
#endif

#endif
