/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***   SmilParser.c   ***
 ************************/

#include <stdlib.h>
#include <string.h>

#include	"Uigp/igp.h"

#include	"Ucst/CstType.h"


#include	"CfgType.h"


static void		cst_put_cfg_stringA( cst_type *cst, int align, char *name, char *value );


static void	cfg_build( cfg_type *cfg, int align, cst_type *cst );



int
cfg_write_file( cfg_type *cfg, char *file )
{
cst_type *cst;
	

	cst = cst_alloc( 10000 );

	cfg_build( cfg, 0, cst );


	cst_write_to_file( cst, file );

	cst_destroy( cst, 1 );

	return( 1 );
}


static void
cfg_build( cfg_type *cfg, int align, cst_type *cst )
{
cfg_type *c;
cfgAttr_type	*a;

	for( a = cfg->pAttr ; a != NULL ; a = a->next )
		cst_put_cfg_stringA( cst, align, a->name, a->data );


	for( c = cfg->pCfg ; c != NULL ; c = c->next ){

		cst_put_xml_tag_openA( cst, align, c->name );

		cfg_build( c, align+1, cst );

		cst_put_xml_tag_closeA( cst, align, c->name );
	}
}


static void	
cst_put_cfg_stringA( cst_type *cst, int align, char *name, char *value )
{
int	i;

	for( i = 0 ; i < align ; i++ )
		CST_PUT_CHAR( cst , '\t' );

	cst_put_string( cst, name );
	CST_PUT_CHAR( cst , '=' );

	cst_put_string( cst, value );

	CST_PUT_CHAR( cst , '\n' );
}
