/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>

#include	"Uigp/igp.h"
#include	"Config3d.h"



void
config3d_read( FILE *fp, config3d *cp )
{
	fscanf( fp, "%f %f %f  %f %f %f",
		&cp->x, &cp->y, &cp->z,
		&cp->u1, &cp->u2, &cp->u3 );
}


void
config3d_write( FILE *fp, config3d *cp )
{
	fprintf( fp, "%.4f %.4f %.4f  %.4f %.4f %.4f\n",
		cp->x, cp->y, cp->z,
		cp->u1, cp->u2, cp->u3 );
}



int
config3d_load( char *file, config3d cp[], int *cp_no )
{
FILE	*fp;
int	i;

	if( (fp = fopen( file, "r" ) ) == NULL ){
		warning( "config3d_load", "Can't open file" );
		return( -1 );
	}

	fscanf( fp, "%d", cp_no );

	for( i = 0 ; i < *cp_no ; i++ )
		fscanf( fp, "%f %f %f  %f %f %f",
			&cp[i].x, &cp[i].y, &cp[i].z,
			&cp[i].u1, &cp[i].u2, &cp[i].u3 );

	fclose( fp );

	return( *cp_no );
}



int
config3d_dump( char *file, config3d cp[], int cp_no )
{
FILE	*fp;
int	i;

	if( (fp = fopen( file, "w" ) ) == NULL ){
		warning( "config3d_dump", "Can't open file" );
		return( -1 );
	}

	fprintf( fp, "%d\n", cp_no );

	for( i = 0 ; i < cp_no ; i++ )
		fprintf( fp, "%.4f %.4f %.4f  %.4f %.4f %.4f\n",
			cp[i].x, cp[i].y, cp[i].z,
			cp[i].u1, cp[i].u2, cp[i].u3 );

	fclose( fp );
	return( cp_no );
}


