/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	BstTool.c	***
 **************************/
#include	<stdio.h>

#include	"Uigp/igp.h"

#include	"FbstType.h"


fbst_type *
fbst_alloc()
{
fbst_type *bst;

	bst = (fbst_type *)malloc( sizeof(fbst_type) );

	bst->byte_i = 0;

	bst->byte =  0;
	bst->MaskIndex = 0;
	bst->mask = 0x80;

	return( bst );
}


void
fbst_free( fbst_type *bst )
{
	free( bst );
}



fbst_type *
fbst_open_to_write( char *file_name )
{
fbst_type *bst;
FILE	*fp;

	if( (fp = fopen( file_name, "wb" )) == NULL )
		return( NULL );

	bst = fbst_alloc();
	bst->fp = fp;

	bst->MaskIndex = 0;


	return( bst );
}


fbst_type *
fbst_open_to_read( char *file_name )
{
fbst_type *bst;
FILE	*fp;


	if( (fp = fopen( file_name, "rb" )) == NULL )
		return( NULL );

	bst = fbst_alloc();
	bst->fp = fp;

	bst->MaskIndex = 8;

	return( bst );
}


fbst_type *
fbst_set_to_read( FILE *fp )
{
fbst_type *bst;

	bst = fbst_alloc();
	bst->fp = fp;

	bst->MaskIndex = 8;

	return( bst );
}



void
fbst_close( fbst_type *bst, int Fwrite )
{
	if( Fwrite && bst->MaskIndex != 0 )
		putc( bst->byte, bst->fp );

	fclose( bst->fp );

	free( bst );
}
