/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	GioType.h	***
 **************************/

#ifndef		_GIO_TYPE_
#define		_GIO_TYPE_

#include 	"Ucst/CstType.h"
#include 	"Uigp/igp.h"



typedef struct gio_type {

	FILE *fp;

	cst_type        *cst;

	int	bytes;

	int	Fdata;

} 	gio_type;




#define GIO_GETC( gio )  (( gio->fp != NULL )? \
                        fgetc(gio->fp) : CST_GETUC(gio->cst) )

#define GIO_PUTC( gio, c )  (( gio->fp != NULL )? \
                        fputc( c, gio->fp) : CST_PUTC(gio->cst, c) )


#define GIO_END( gio )  (( gio->fp != NULL )? feof(gio->fp) : CST_END( gio->cst ))



gio_type *	gio_alloc();

void	gio_close( gio_type *gio );



gio_type *  gio_open_file_to_read( const char *file );  

gio_type *	gio_open_file_to_write( const char *file );

gio_type *  gio_open_buffer_to_read( char *data, int byte_no, int Fdata );

gio_type *  imageIo_open_cst( cst_type *cst );



//#define	LITTLE_ENDIAN	0
//#define BIG_ENDIAN		1

void	gio_put_no( gio_type *gio, int a, int nByte, int Fendian );

int	gio_get_no( gio_type *gio, int nByte, int Fendian );

void	gio_put_noM( gio_type *gio, int a, int nByte );

int	gio_get_noM( gio_type *gio, int nByte );


void	gio_put_noL( gio_type *gio, int a, int nByte );

int	gio_get_noL( gio_type *gio, int nByte );


int	gio_get_buffer( gio_type *gio, u_char buf[], int byte_no );

int	gio_put_buffer( gio_type *gio, u_char buf[], int byte_no );

long	gio_ftell( gio_type *gio );

int	gio_seek( gio_type *gio, int pos );

long	gio_bytes( gio_type *gio );

char	gio_getc( gio_type *gio );

unsigned char	gio_getuc( gio_type *gio );

#endif 
