/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	GpByteOrder.c ***
 ************************/
#include	<string.h>

#include	"Uigp/igp.h"



int
gp_byte_order()
{
char s[5];
union
{
	long longval;
    char charval[4];
} probe;

    probe.longval = 0x41424344L;  /* ABCD in ASCII */
    strncpy( s, probe.charval, sizeof(long) );
    s[4] = '\0';

    if ( strcmp(s, "ABCD") == 0 )
        return BIG_ENDIAN;

    //else if ( strcmp(s, "DCBA") == 0 )
    return LITTLE_ENDIAN;
}




void 
gp_byte_order_swap_short( short *loc, int no )
{
int i;
short thisval;
char *dst, *src;

    src = (char *) &thisval;
    for ( i = 0; i < no; i++ )
    {
        thisval = *loc;
        dst = (char *)loc++;

        dst[0] = src[1];
        dst[1] = src[0];
    }
}

void 
gp_byte_order_swap_int( int *loc, int no )
{
int i;
int thisval;
char *dst, *src;

    src = (char *) &thisval;
    for ( i = 0; i < no; i++ )
    {
        thisval = *loc;
        dst = (char *)loc++;

        dst[0] = src[3];
        dst[1] = src[2];
		dst[2] = src[1];
		dst[3] = src[0];
    }
}

