/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/********************
 ***	GpMsg.c   ***
 ********************/

#include <stdio.h>
#include <stdlib.h>

#ifdef	WIN32
#include  <windows.h>
#include  <Wincon.h>
#endif


#include "igp.h"


void urte_msg( char *msg )
{

#ifdef WIN32

	char buff[256];
	DWORD dwRet = GetConsoleTitle(buff, 256);

	if( dwRet != 0 )
		fprintf( stderr , msg );
	else {
#ifdef _UNICODE
		wchar_t buf[1024];
		wsprintf(buf, L"%S", msg);
		MessageBox( 0, buf, L"Urte Msg", MB_OK | MB_ICONEXCLAMATION);;
#else		
		MessageBox( 0, msg, "Urte Msg", MB_OK | MB_ICONEXCLAMATION);
#endif
	}
  
#else
#ifndef PALMOS
  fprintf( stderr , msg );
#endif
#endif
}


void error( char *sender ,char *msg )
{
  char error_msg[1024];

//  sprintf( error_msg, "\nError in : %s\n%s\n", sender, msg );
  sprintf( error_msg, "Error from: %s - %s\n", sender, msg );
  urte_msg( error_msg );
  exit(1);

}

void warning( char *sender, char *msg )
{
  char warning_msg[256];

  sprintf( warning_msg, "Warning from: %s - %s\n", sender, msg );
  urte_msg( warning_msg );
}




/*	for debug */

void
puchar( u_char *a, int no )
{
int i;
	for( i = 0 ; i < no ; i++ )
	{
#ifndef PALMOS
		fprintf( stderr, "%4d   ", (int)a[i] );
#endif
	}
#ifndef PALMOS
	fprintf( stderr, "\n");
#endif
}


void
pchar( char *a, int no )
{
int i;
	for( i = 0 ; i < no ; i++ )
	{
#ifndef PALMOS
		fprintf( stderr, "%4d   ", (int)a[i] );
#endif
	}
#ifndef PALMOS
	fprintf( stderr, "\n");
#endif
}


void
pushort( u_short *a, int no )
{
int i;
	for( i = 0 ; i < no ; i++ )
	{
#ifndef PALMOS
		fprintf( stderr, "%4d   ", (int)a[i] );
#endif
	}
#ifndef PALMOS
	fprintf( stderr, "\n");
#endif
}

void
pshort( short *a, int no )
{
int i;
	for( i = 0 ; i < no ; i++ )
	{
#ifndef PALMOS
		fprintf( stderr, "%4d   ", (int)a[i] );
#endif
	}
#ifndef PALMOS
	fprintf( stderr, "\n");
#endif
}

void
pint( int *a, int no )
{
int i;
	for( i = 0 ; i < no ; i++ )
	{
#ifndef PALMOS
		fprintf( stderr, "%4d   ", (int)a[i] );
#endif
	}
#ifndef PALMOS
	fprintf( stderr, "\n");
#endif
}

void
pfloat( float *a, int no )
{
int i;
	for( i = 0 ; i < no ; i++ )
	{
#ifndef PALMOS
		fprintf( stderr, "%.2f   ", a[i] );
#endif
	}
#ifndef PALMOS
	fprintf( stderr, "\n");
#endif
}



void
pbit( int code, int no )
{
	while ( no-- != 0 ) {

		if ( code & 1L )
		{
#ifndef PALMOS
			fprintf( stderr, "1 " );
#endif
		}
		else
		{
#ifndef PALMOS
			fprintf( stderr, "0 " );
#endif
		}

		code >>= 1;
	}
#ifndef PALMOS
	fprintf( stderr, "\n");
#endif
}



void
wno( char * name, int no )
{
char	msg[256];
	sprintf( msg, "%d", no );
	warning( name, msg );
}

void
wnof( char * name, float	no )
{
char	msg[256];
	sprintf( msg, "%f", no );
	warning( name, msg );
}