/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<math.h>

#include	"uinf.h"


void inf_init( inf *st )
{
	*st = Inf_init;
}


void inf_update( float 	val, inf	*sinf )
{
 	sinf->num ++;
	sinf->sum += val;
	sinf->sum2 += val*val;

	if( val > 0 )
		sinf->abs_sum += val;
	else	sinf->abs_sum -= val;

	if (sinf->min > val)
		sinf->min = val ;  

        if (sinf->max < val)
		sinf->max = val ;
}



void
inf_print(  FILE *fp, char *s, inf *sinf, float nf )
{
float	av,	var,	var2;

	if( sinf->num == 0 ){
		fprintf(fp, "%-10.10s: %5d    M: %6.2f %6.2f    Av: %6.2f   A: %6.2f   V: %6.2f\n", 
			s,
			0, 0.0, 0.0, 0.0, 0.0, 0.0 );
		return;
	}


	av = sinf->sum*nf/sinf->num;
	var2 = sinf->sum2*nf*nf/sinf->num - av*av;
	var = ( var2 < 0 )? 0 : sqrt(var2);

	fprintf(fp, "%-10.10s: %5d    M: %6.2f %6.2f    Av: %6.2f   A: %6.2f   V: %6.2f\n", 
			s,
			sinf->num,
			sinf->min*nf,
			sinf->max*nf, 
			av,
			sinf->abs_sum/ sinf->num,
			var );
}


void
inf_print_array( FILE *fp, char *s, int a[], int no )
{
int	i,	sum0,	sum1;	

	sum0 = sum1 = 0;

	fprintf( fp, "\n\n%s\n", s );
	for( i = 0 ; i < no ; i++ ){
		if( a[i] == 0 )	continue;
		fprintf( fp, "     %2d   - %5d\n", i, a[i] );
		sum1 += a[i];
		sum0 += a[i] * i;
	}

	fprintf( fp, "%7d   - %5d\n", sum0, sum1 );
}
