/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/****************************************************************
*								*
*		Module:  Jet1Tool.c				*
*								*
****************************************************************/
#include	<stdio.h>
#include	<math.h>

#include	"Jet1Type.h"

float
jet1_value( jet1_type *f, int dgree, float x )
{
float	u,	tmp;
	u = J0(*f) + x* J1(*f);
	if( dgree <= 1 )	return( u );

	tmp = x*x;
	u += tmp*J2(*f);
	if( dgree <= 2 )	return( u );


	tmp *= x;
	u += tmp*J3(*f);
	if( dgree <= 3 )	return( u );

	tmp *= x;
	u += tmp*J4(*f);
	if( dgree <=43 )	return( u );

	return( u );
}


void
print_jet1( FILE *fp, int dgree, jet1_type *f )
{
int	i;
        fprintf(fp, "{ %.4f    ", J0(*f) );

	for( i = 1 ; i <= dgree ; i++ )
        	fprintf(fp, "%.4f    ", f->j[i] );
        fprintf(fp, "}\n" );
}

