/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/****************************************************************
*								*
*		Module:  jettype.h				*
*								*
****************************************************************/

#ifndef         JET1D_TYPE
#define         JET1D_TYPE

#include	<stdio.h>

#define		JET1_ORDER	3
#define		JET1_COEFF_NO	( JET1_ORDER + 1)


typedef	struct	jet1	{
	float	j[ JET1_COEFF_NO ];
} jet1_type;



static jet1_type	ZERO_JET1 = { 0.0, 0.0, 0.0, 0.0 };



#define		J0( f )		(f).j[0]
#define		J1( f )		(f).j[1]
#define		J2( f )		(f).j[2]
#define		J3( f )		(f).j[3]
#define		J4( f )		(f).j[4]



	/* Jet1dTool.c */

#define	JET1_2_VALUE( f, x )	( J0(f) + x* ( J1(f) + x* J2(f) )  )
#define	JET1_3_VALUE( f, x )	( J0(f) +x*( J1(f) +x*( J2(f) +x*J3(f) ) ) )

float		jet1_value( jet1_type *f, int dgree, float x );

void	print_jet1( FILE *fp, int dgree, jet1_type *f );


#endif
