/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/****************************************************************
*								*
*		Module:  Jet2Io.c				*
*								*
****************************************************************/
#include	<stdio.h>
#include	<math.h>

#include	"Jet2Type.h"

void
print_jet2( FILE *fp, int dgree, jet2 *f )
{
	fprintf(fp, "{ %.4f }\n", J00(*f) );
	fprintf(fp, "{ %.4f    %.4f }\n", J10(*f), J01(*f) );
	fprintf(fp, "{ %.4f    %.4f    %.4f }\n", J20(*f), J11(*f), J02(*f) );

	if( dgree == 2 )	return;

	fprintf(fp, "{ %.4f    %.4f    %.4f    %.4f }\n",
			 J30(*f), J21(*f), J12(*f), J03(*f) );
}


void
load_jet2( FILE *fp, int dgree, jet2 *f )
{
	fscanf(fp, "%f", &J00(*f) );
	fscanf(fp, "%f %f", &J10(*f), &J01(*f) );
	fscanf(fp, "%f %f %f", &J20(*f), &J11(*f), &J02(*f) );

	if( dgree == 2 )	return;

	fscanf(fp, "%f %f %f %f",
		&J30(*f), &J21(*f), &J12(*f), &J03(*f) );
}

