/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef __VIM_JNI_H__
#define __VIM_JNI_H__


#ifdef _DEBUG 
//#pragma comment( lib, "jvm.lib" )
#else
//#pragma comment( lib, "jvm.lib" )
#endif



#include <jni.h>


class CVimJni
{
public:
	CVimJni() {};
	virtual ~CVimJni() {};

	// Create object
	static jobject		CreateObject(JNIEnv *env, char *className, char *method_sig, jvalue *args);

	jobject CreateObject(JNIEnv *env, jclass cls, char *method_sig, jvalue *args );


	static jobjectArray	CreateObjectArray(JNIEnv *env, char *className, int length );

	static jobjectArray CreateObjectArray(JNIEnv *env, jclass cls, int arrLen );


	static jbyteArray CreateJByteArray(JNIEnv *env, char *data, int len);

	static jstring	CreateJString( JNIEnv *env, char *s, int length );


	// get jni variable data
	int GetJByteArrayData( JNIEnv* env, jobject object, jclass cls, char *method,
						   char **data, int *bytes );

	static int		GetJByteArrayData(JNIEnv *env, jbyteArray byteArr, char **data, int *bytes);
	static int		GetJIntArrayData(JNIEnv *env, jintArray byteArr, int **data, int *bytes);


	static char * GetJStringData( JNIEnv* env, jobject object, jclass cls, char *method );

	static char *GetJStringData(JNIEnv *env, jstring js );

	static int	GetJStringData( JNIEnv* env, jobject object, jclass cls, char *method,
						char *data, int len  );

	static int	GetJStringData(JNIEnv *env, jstring js, char *data, int len );


	int	GetJIntData( JNIEnv* env, jobject object, jclass cls, char *method );

	int GetJByteData( JNIEnv* env, jobject object, jclass cls, char *method );


	int	GetJBoolData( JNIEnv* env, jobject object, jclass cls, char *method );


	// get by calling to class method
	static jstring GetJstring( JNIEnv* env, jobject object, jclass cls, char *method );

	static jbyteArray	GetJbyteArray( JNIEnv* env, jobject object, jclass cls, char *method );
};




#endif // __UJNITOOL_H__