/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**********************
 ***   VimJvm.cpp   ***
 **********************/
#include	<string.h>

extern "C" {
#include	"Uigp/igp.h"
}




#include "VimJvm.h"


char * CVimJvm::m_classPath = NULL;
JNIEnv * CVimJvm::m_env = NULL;
JavaVM * CVimJvm::m_vm = NULL;


CVimJvm::CVimJvm() 
{
	m_env = NULL;
	m_vm = NULL;
	m_classPath = NULL;

} 






CVimJvm::~CVimJvm()
{
	if( m_classPath != NULL ){
		free( m_classPath );
		m_classPath = NULL;
	}
}


int	CVimJvm::AddClassPath( char *dir, char *className )
{
char	classPath[2048];

	sprintf( classPath, "%s/%s", dir, className );

	return AddClassPath( classPath );
}



int	CVimJvm::AddClassPath( char *classPath )
{
	if( m_classPath == NULL ){
		m_classPath = strdup( classPath );
		return( 1 );
	}

	int len = strlen( m_classPath ) + strlen( classPath );

	char *s = (char *)malloc( len + 2 );
#ifdef WIN32
	sprintf( s, "%s;%s", m_classPath, classPath );
#else
	sprintf( s, "%s:%s", m_classPath, classPath );
#endif

	free( m_classPath );
	m_classPath = s;

	return( 1 );
}

		

int CVimJvm::LoadJvm()
{
char	*libPath;
int	ret;

	if( m_env != NULL )	return( 0 );

	JavaVMInitArgs vm_args;
	JavaVMOption options[3];
	
	libPath = ( char * )malloc( strlen( m_classPath ) + 25 );

	sprintf( libPath, "-Djava.class.path=%s", m_classPath );
	
	options[0].optionString = "-Djava.compiler=NONE";	/* disable JIT */	
	options[1].optionString = libPath;					/* user classes */
	options[2].optionString = "-verbose:gc,class,jni";	/* do not print JNI-related messages */

	vm_args.version = JNI_VERSION_1_2;
	vm_args.options = options;
#ifdef WIN32
	vm_args.nOptions = 3;
#else
	vm_args.nOptions = 2;
#endif
	vm_args.ignoreUnrecognized = true;

/* Note that in the Java 2 SDK, there is no longer any need to call 
 * JNI_GetDefaultJavaVMInitArgs. 
 */
	ret = JNI_CreateJavaVM( &m_vm, (void **)&m_env, &vm_args);

	free( libPath );
	return( ret );
}




