/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
// Configurator.h: interface for the CConfigurator class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __VIM_JVM_H__
#define __VIM_JVM_H__


#ifdef _DEBUG 
#pragma comment( lib, "jvm.lib" )
#else
#pragma comment( lib, "jvm.lib" )
#endif



#include <jni.h>


class CVimJvm
{
public:
	CVimJvm();
	virtual ~CVimJvm();

	int	LoadJvm();

	int	AddClassPath( char *dir, char *className );

	int	AddClassPath( char *classPath );


public:
	static char *m_classPath;
	static JNIEnv *m_env;
	static JavaVM *m_vm;
};



#endif



