/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/********************
 *** UjniTool.c   ***
 ********************/

#include "stdafx.h"
#include	<string.h>
#include "UjniTool.h"


jobject 
ujni_newObject(JNIEnv *env, char *className, char *method_sig, jvalue *args)
{
	jclass cls = env->FindClass(className);
	if (cls)
	{
		jmethodID method = env->GetMethodID(cls, "<init>", method_sig);
		if (method)
		{
			return env->NewObjectA(cls, method, args);
		}
	}
	return NULL;
}



jobjectArray 
ujni_newObjectArray(JNIEnv *env, char *className, int arrLen)
{
	jclass cls = env->FindClass(className);
	if (cls)
	{
		
		return env->NewObjectArray(arrLen, cls, NULL);
	}
	return NULL;
}





jbyteArray 
ujni_createJByteArray(JNIEnv *env, char *data, int len)
{

	jbyte *jdata = new jbyte[len];
	for (int i = 0; i < len; i++)
		jdata[i] = data[i];


	jbyteArray byteArr = env->NewByteArray(len);
	if (!byteArr)	NULL;


	env->SetByteArrayRegion(byteArr, 0, len, jdata );

	delete jdata;

	return byteArr;
}


int 
ujni_getJByteArrayData(JNIEnv *env, jbyteArray byteArr, char **data, int *len)
{
	*len = env->GetArrayLength( byteArr);
	env->GetArrayLength( byteArr);
	jbyte *jdata = new jbyte[*len];

	env->GetByteArrayRegion(byteArr, 0, *len, jdata );


	*data = new char[*len];
	for (int i = 0; i < *len; i++)
		(*data)[i] = jdata[i];


	delete jdata;

	return 1;
}

int 
ujni_getJIntArrayData(JNIEnv *env, jintArray byteArr, int **data, int *len)
{
	*len = env->GetArrayLength( byteArr);
	env->GetArrayLength( byteArr);
	jint *jdata = new jint[*len];

	env->GetIntArrayRegion(byteArr, 0, *len, jdata );


	*data = new int[*len];
	for (int i = 0; i < *len; i++)
		(*data)[i] = jdata[i];


	delete jdata;

	return 1;
}


jstring 
ujni_createJString( JNIEnv *env, char *data, int len )
{

/*
	
	jvalue args[2];
	args[0].l = ujni_createJByteArray( env, data, len );

	args[1].l = NULL;

	
	jstring jstr = (jstring)ujni_newObject(
			env, 
			"java.lang.String", 
			"([B)V",
			args);


	return( jstr );
*/
	if( len <= 0 )
		return( env->NewStringUTF(data) );

	char buf[256];
	strncpy( buf, data, len );
	return( env->NewStringUTF(buf) );
}


const char *
ujni_getJString(JNIEnv *env, jstring js)
{
	if (js==NULL) {
		return NULL;
	} else {
		return env->GetStringUTFChars(js, NULL);
	}
}
