/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************** LZW12.C *************************
 *
 * This is 12 bit LZW program. 
 * It uses a fixed size code, and does not attempt to flush the dictionary after it fills up.
 */

#ifndef	__LZ15_H__
#define __LZ15_H__
#include "Ubst/BstType.h"
#include "Ucst/CstType.h"


 /*
 * BITS defines how many bits will be in a code.  
 * TABLE_SIZE defines the size of the dictionary table.
 */
 



/*
 * This data structure defines the dictionary.  Each entry in the dictionary
 * has a code value.  This is the code emitted by the compressor.  Each
 * code is actually made up of two pieces:  a parent_code, and a
 * character.  Code values of less than 256 are actually plain
 * text codes.
 */

typedef struct dictionary {
    int code_value;
    int parent_code;
    char character;
} dictionary;


void initializeDictionary();


/*	LzEncoding.c	*/
bst_type *	lz_encoding( cst_type *cst );


/*	LzDecoding.c	*/
cst_type *	lz_decoding( bst_type *bst );


/*	Lz12Encoding.c	*/
bst_type *	lz12_encoding( cst_type *cst );


/*	Lz12Decoding.c	*/
cst_type *	lz12_decoding( bst_type *bst, int size );



#endif//	__LZ15_H__

