/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/************************
 ***	Mat2fBase.c   ***
 ************************/
#include	<stdio.h>

#include	<math.h>



#include	"Umat/Mat2fType.h"




void 
mat2f_base_ortonormalize( mat2f_type *m[], int no )
{
int i,	j;
float	t;

	for( i = 0 ; i < no ; i++ ){

		for( j = 0 ; j < i ; j++ ){

			t = mat2f_inner( m[j],m[i] );

			ma2f_accumulate( m[i], m[j], -t );
		}


		t = mat2f_inner( m[i],m[i] );

		mat2f_mult_const( m[i], 1.0 / sqrt(t) );
	}
}



void 
mat2f_base_apply( mat2f_type *base[] ,int no, mat2f_type *mat, float f[] )
{
int i;


	for (i = 0; i < no ; i++)
		*f++ = mat2f_inner( base[i], mat );		
}


void 
mat2f_base_apply_inv( mat2f_type *base[] ,int no, float f[], mat2f_type *mat )
{
int i;

	mat2f_mult_const( mat, 0.0 );

	for (i = 0; i < no ; i++ )
		ma2f_accumulate( mat, base[i], f[i] );
}


void 
mat2f_base_free( mat2f_type *base[], int no )
{
int i;

	for (i = 0; i < no ; i++)
		mat2f_free( base[i] );	
}
