/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*************************
 ***	Mat2fBaseDct   ***
 *************************/

#include	<stdio.h>

#include	<math.h>

#include	"Uigp/igp.h"
#include	"Umat/Mat2fType.h"

static mat2f_type *		mat2f_dct_sample( int n, int m,int N, int M );



void
mat2f_base_dct( mat2f_type *base[], int N, int M ) 
{
int	n,	m,	i;

	i = 0;
	for( n = 0 ; n < N ; n++ )
		for( m = 0 ; m < M ; m++ )
			base[i++] = mat2f_dct_sample( n, m, N, M );

	mat2f_base_ortonormalize( base, N*M );

}


static mat2f_type * 
mat2f_dct_sample( int n, int m,int N, int M )
{
int	i,	j;
float x, y,	cosy,	*f;
mat2f_type *mat;





	mat = mat2f_alloc( N, M);

	f = mat->f;
	for( i=0; i < N ; i++ ){

		y = ((2*i+1)*n* M_PI )/(2.0*N);

		cosy = cos( y );

		for ( j = 0 ; j < M ; j++ ){

			x = ((2*j+1)*m* M_PI )/(2.0*M);
		

			*f++ = cos(x)* cosy;

		}
	}

	return( mat );
}
