/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	<malloc.h>

#include	"Mat2fType.h"



mat2f_type *
mat2f_alloc( int ni, int nj )
{
mat2f_type	*m;

	m = ( mat2f_type *)malloc( sizeof( mat2f_type ) );

	m->ni = ni;
	m->nj = nj;

	m->f = (float *)malloc( sizeof( float )*m->ni*m->nj );

	return( m );
}



void
mat2f_free( mat2f_type *mat )
{
	free( mat->f );

	free( mat );
}


float
mat2f_inner( mat2f_type *m1, mat2f_type *m2 )
{
int	i,	j;
float	*f1,	*f2;
float	a;

	a = 0;

	for( i = 0, f1 = m1->f, f2 = m2->f ; i < m1->ni ; i++ )
		for( j = 0 ; j < m1->nj ; j++, f1++, f2++ )
			a += (*f1) * (*f2);

	return( a );
}


mat2f_type *
mat2f_add( mat2f_type *m1, mat2f_type *m2 )
{
mat2f_type	*m;
int	i;
float	*f,	*f1,	*f2;


	m = mat2f_alloc( m1->ni, m2->nj );

	f1 = m1->f;
	f2 = m2->f;
	f = m->f;
	for( i = 0 ; i < m->ni*m->nj ; i++, f++, f1++, f2++ ){
		*f = (*f1) + (*f2);
	}

	return( m );
}

void
ma2f_accumulate( mat2f_type *m, mat2f_type *m1, float t )
{

int	i;
float	*f,	*f1;


	f1 = m1->f;
	f = m->f;
	for( i = 0 ; i < m->ni*m->nj ; i++, f++, f1++ ){
		*f += t * (*f1);
	}
}



void
mat2f_const( mat2f_type *m, float a )
{
int	i;
float	*f;


	for( i = 0, f = m->f ; i < m->ni*m->nj ; i++, f++ )
		*f = a;
}

void
mat2f_add_const( mat2f_type *m, float a )
{
int	i;
float	*f;


	for( i = 0, f = m->f ; i < m->ni*m->nj ; i++, f++ )
		*f += a;
}


void
mat2f_mult_const( mat2f_type *m, float a )
{
int	i;
float	*f;


	for( i = 0, f = m->f ; i < m->ni*m->nj ; i++, f++ )
		*f *= a;
}
