/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

/****************************************************************
*								*
*               Module:  Compare.c				*
*								*
****************************************************************/

#include        <stdio.h>
#include        <math.h>
#include        "Uigp/igp.h"

#include        "mbmap.h"

float
mbmap_variability( mbmap bmap1, mbmap bmap2, int x0,int y0,int row,int column )
{
float	sum = 0,	tmp,	var;
u_char	*sp1,	*sp2;
int	i,	j;

	for( i = 0 ; i < row ; i++ ){

		sp1 = MBMAP_PIXEL_ADRESS( bmap1, x0+i, y0 );
		sp2 = MBMAP_PIXEL_ADRESS( bmap2, x0+i, y0 );

		for( j = 0 ; j < column ; j++ ){
			tmp = (float)(*sp1++) - (float)(*sp2++);
			sum += tmp*tmp;
		}
	}
	var = sqrt( sum/(row*column) );
	return( var );
}


float
mbmap_average( mbmap bmap1, mbmap bmap2, int x0,int y0,int row,int column )
{
float	sum, 	tmp,	average;
u_char	*sp1,	*sp2;
int	i,	j;

	sum = 0;
	for( i = 0 ; i < row ; i++ ){

		sp1 = MBMAP_PIXEL_ADRESS( bmap1, x0+i, y0 );
		sp2 = MBMAP_PIXEL_ADRESS( bmap2, x0+i, y0 );

		for( j = 0 ; j < column ; j++ )
			sum += (float)(*sp1++) - (float)(*sp2++);
	}
	average = sum/(row*column);
	return( average );
}

