/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#include	<stdio.h>
#include	"Uigp/igp.h"
#include	"mbmap.h"


void
mbmap_convol_3x3( mbmap bmap, float Matr_conv[3][3],
		int row, int col, mbmap *bmap_conv, int alloc_flag )
{
u_char	*tp,	*sp,	*p;
int	algin_conv,	algin_sp,	algin_tp;
int	i,	j,	n,	k;
float	temp;

	if( alloc_flag == 0 )
		MBMAP_CREATE( *bmap_conv, row, col );

	sp = MBMAP_PIXEL_ADRESS( bmap, 0, 0 );
	tp = MBMAP_PIXEL_ADRESS( *bmap_conv, 0, 0 );

	algin_tp = MBMAP_COLUMN( *bmap_conv )- col;
	algin_sp = MBMAP_COLUMN( bmap ) - col;

	algin_conv = MBMAP_COLUMN( bmap ) - 3;

	for ( i = 0; i < row ; i++, sp += algin_sp, tp += algin_tp )
		for ( j = 0; j < col ; j++, tp++, sp++ ) {

			if( i == 0 || i == row-1 || j == 0 || j == col-1 ){
				*tp = *sp;
				continue;
			}


			p = sp - MBMAP_COLUMN( bmap ) - 1;
			temp = 0;
			for( n = 0 ; n < 3 ; n++, p += algin_conv )
				for( k = 0 ; k < 3 ; k++, p++ )
					temp += (*p)*Matr_conv[n][k];

			*tp = (u_char)PUSH_TO_RANGE( temp, 0, 255 );
		}
}



void
mbmap_convolution( mbmap bmap, float *Matr_conv, int Mno,
		int row, int column, mbmap *bmap_conv, int alloc_flag )
{
u_char	*tp,	*sp,	*p;
int	algin_conv,	algin_sp,	algin_tp;
int	i,	j,	n,	k,	mh;
float	*m,	temp,	w;

	if( alloc_flag == 0 )
		MBMAP_CREATE( *bmap_conv, row, column );

	sp = MBMAP_PIXEL_ADRESS( bmap, 0, 0 );
	tp = MBMAP_PIXEL_ADRESS( *bmap_conv, 0, 0 );

	algin_tp = MBMAP_COLUMN( *bmap_conv )- column;
	algin_sp = MBMAP_COLUMN( bmap ) - column;

	algin_conv = MBMAP_COLUMN( bmap ) - Mno;

	mh = Mno/2;

	for ( i = 0; i < row ; i++, sp += algin_sp, tp += algin_tp )
		for ( j = 0; j < column ; j++, tp++, sp++ ) {


			p = sp - mh*MBMAP_COLUMN( bmap ) - mh;
			m = Matr_conv;
			temp = 0;
			w = 0;

			for( n = i-mh ; n <= i+mh ; n++, p += algin_conv ){

				if( n < 0 || n >= row )	continue;

				for( k = j-mh ; k <= j+mh ; k++, p++, m++ ){
					if( k < 0 || k >= column )
						continue;
					temp += (*p)*(*m);
					w += *m;
				}
			}
	
			if( w != 1.0 )	temp /= w;

			*tp = (u_char)PUSH_TO_RANGE( temp, 0, 255 );
		}
}
