/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/

#include	"Umbmap/mbmap.h"
#include	"Uimage/ImageType.h"



int
mbmap_from_image( image_type *im, mbmap bmap[], int flag )
{
u_char	*r,	*g,	*b;
u_int	*p;
int	i,	j;

	if( flag ){
		MBMAP_CREATE(bmap[0], im->row, im->column );
		MBMAP_CREATE(bmap[1], im->row, im->column );
		MBMAP_CREATE(bmap[2], im->row, im->column );
	}
	else	{
		MBMAP_RECREATE(bmap[0], im->row, im->column );
		MBMAP_RECREATE(bmap[1], im->row, im->column );
		MBMAP_RECREATE(bmap[2], im->row, im->column );
	}

	r = MBMAP_DATA_ADRESS( bmap[0] );
	g = MBMAP_DATA_ADRESS( bmap[1] );
	b = MBMAP_DATA_ADRESS( bmap[2] );

	p = (u_int *)im->data;
	for( i = 0 ; i < im->row ; i++, p += im->pad )
		for( j = 0 ; j < im->column ; j++ ){
			*b++ = IMAGE4_BLUE( *p );
			*g++ = IMAGE4_GREEN( *p );
			*r++ = IMAGE4_RED( *p );
			p++;
		}

	return( 4 );
}



image_type *
mbmap_to_image( mbmap bmap[] )
{
u_char	*r,	*g,	*b;
u_int	*p;
int	i,	j;
int	row,	column;
image_type	*im;

	r = MBMAP_DATA_ADRESS( bmap[0] );
	g = MBMAP_DATA_ADRESS( bmap[1] );
	b = MBMAP_DATA_ADRESS( bmap[2] );

	row = MBMAP_ROW(bmap[0]);
	column = MBMAP_COLUMN(bmap[0]);

	im = image_create( row, column, 4, 1, NULL );

	p = (u_int *)im->data;
	for( i = 0 ; i < im->row ; i++, p += im->pad )
		for( j = 0 ; j < im->column ; j++ ){

			*p++ = IMAGE4_RGB( *r, *g, *b );
			r++;
			g++;
			b++;
		}

	return( im );
}
