/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/****************************************************************
 *								*
 *		Module:  mbmap_io.c				*
 *								*
 ****************************************************************/

#include	<stdio.h>

#include	<fcntl.h>

#include	"Uigp/igp.h"
#include	"mbmap.h"


void
mbmap_dump_rgb_to_row_line( int fd, mbmap r, mbmap g, mbmap b )
{
int	i;
u_char	*rp,	*gp,	*bp;

	rp = MBMAP_DATA_ADRESS(r);
	gp = MBMAP_DATA_ADRESS(g);
	bp = MBMAP_DATA_ADRESS(b);

	for( i = 0 ; i < MBMAP_ROW( r ) ; i++ ){
  		write( fd, (char *)rp, MBMAP_COLUMN( r ) );
		rp += MBMAP_COLUMN( r );

  		write( fd, (char *)gp, MBMAP_COLUMN( g ) );
		gp += MBMAP_COLUMN( g );

  		write( fd, (char *)bp, MBMAP_COLUMN( b ) );
		bp += MBMAP_COLUMN( b );

	}
}


void
mbmap_dump_rgb_to_row_pixel( int fd, mbmap r, mbmap g, mbmap b )
{
int	i,	j,	column;
u_char	*rp,	*gp,	*bp,	*buf,	*p;



	column = MBMAP_COLUMN( r );
	if( (buf = (u_char *)malloc((u_long)3* column ) ) == NULL )
		error( "mbmap_dump_rgb_to_row_pixel", "malloc return Null" );

	rp = MBMAP_DATA_ADRESS(r);
	gp = MBMAP_DATA_ADRESS(g);
	bp = MBMAP_DATA_ADRESS(b);

	for( i = 0 ; i < MBMAP_ROW( r ) ; i++ ){

		for( j = 0, p = buf ; j < column ; j++ ){
			*p++ = *rp++;
			*p++ = *gp++;
			*p++ = *bp++;
		}

  		write( fd, (char *)buf, 3* column );
	}

	free( (char *) buf );
}
