/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef _IM_HDR_

#define _IM_HDR_

#include <string.h>

struct IM_HEADER	{
	char	h[4];	/* "GP1 "	*/
	long	column;
	long	row;
	char	image_name[20];
	char	comments[32];
};


#define		IM_HEADER_SIZE	sizeof( struct IM_HEADER )

#define	FILL_IM_HEADER( im_h, c, r, name, comm )	\
	strncpy( im_h.h, "GP1 ", 4 ); \
	im_h.column = c; \
	im_h.row = r; \
	if( name != NULL )	strncpy( im_h.image_name, name, 20 ); \
	if( comm != NULL )	strncpy( im_h.comments, comm, 32 );

#define		IM_IS_GP_BMAP_FILE( im_h )	\
			( strncmp( im_h.h, "GP1 ", 4) == 0 )


#endif  /* _IM_HDR_ */
