/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/****************************
 ***	MediaDataRead.c   ***
 ****************************/
#include <stdio.h>
#include <string.h>

#include "Uigp/igp.h"

#include "MediaDataType.h"




mediaData_type *
mediaData_read_file( char *file )
{
char	extension[256];
mediaData_type *md;
FILE	*fp;
int	bytes,	mdType;

	gp_filename_extract_extension( file, extension, 256 );
	mdType = mediaData_mime2format( extension );
	if( mdType < 0 )	return( NULL );


	bytes = gp_file_size( file );


	if( (fp = fopen(file,"rb")) == NULL )
		return( NULL );


	md = mediaData_alloc( bytes );	

	fread( md->data, sizeof( u_char ), md->bytes, fp );

	fclose( fp );



	md->type = mdType;


	return( md );	
}




void
mediaData_write_to_file( mediaData_type *md, char *fileName )
{
char	file[256],	extension[256];
FILE *fp;

	mediaData_format2extension( md->type, extension );
	strcpy( file, fileName );
	gp_filename_force_extension( file, extension );

	if( (fp = fopen(file,"wb")) == NULL )
		return;
	

	fwrite( md->data, sizeof( u_char ), md->bytes, fp );

	fclose( fp );
}
