/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**************************
 ***	mediaDataTool.c	***
 **************************/
#include	"Uigp/igp.h"

#include	"MediaDataType.h"



mediaData_type *
mediaData_alloc( int bytes )
{
	mediaData_type *md = (mediaData_type *)malloc(sizeof(mediaData_type));
	memset(md, 0, sizeof(mediaData_type));

	md->bytes = bytes;
	md->data = (char *)malloc( sizeof(char)*md->bytes );

	md->sec = -1;

	return md;
}



void
mediaData_destroy(mediaData_type * md)
{
	if( md->data != NULL ) 
	{
		free( md->data );
		md->data = NULL;
	}

	free (md);
}


mediaData_type *
mediaData_make_copy( mediaData_type *smd )
{
mediaData_type *md;

	md = mediaData_alloc( smd->bytes );

	md->type = smd->type;

	md->bytes = smd->bytes;

	memcpy( md->data, smd->data, smd->bytes );

	md->sec = smd->sec;

	return( md );
}


mediaData_type *
mediaData_create( int mediaType, char *data, int bytes )
{
mediaData_type *md;

	md = (mediaData_type *)malloc(sizeof(mediaData_type));

	md->type = mediaType;

	md->bytes = bytes;

	md->data = data;

	md->sec = -1;

	return( md );
}
