/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/****************************
 ***	MediaDataRead.c   ***
 ****************************/
#include <stdio.h>
#include <string.h>

#include "Uigp/igp.h"

#include "MediaDataType.h"


static int	mediaData_format_from_extension( char *file );







int
mediaData_mime2format( char *mime )
{
	if( gp_stricmp( mime, "audio/midi" ) == 0 || gp_stricmp( mime, "audio/mid" ) == 0 || gp_stricmp( mime, ".mid") == 0 )
		return( MA_MIDI );

	if( gp_stricmp( mime, "audio/wav" ) == 0 || gp_stricmp( mime, ".wav") == 0 )
		return( MA_WAV );

	if( gp_stricmp( mime, "audio/wma" ) == 0 || gp_stricmp( mime, ".wma") == 0 )
		return( MA_WMA );

	if( gp_stricmp( mime, "audio/mp3" ) == 0 || gp_stricmp( mime, ".mp3") == 0 )
		return( MA_MP3 );

	// Eli
	if( gp_stricmp( mime, "audio/amr" ) == 0 || gp_stricmp( mime, ".amr") == 0 )
		return( MA_AMR );

	return( -1 );
}


char *
mediaData_mime( mediaData_type *md, char *mime )
{
	return( mediaData_format2mime(md->type, mime ) );
}


char *
mediaData_format2mime( int format, char *mime )
{
	mime[0] = 0;
	switch( format ){
	case MA_MIDI:
			strcpy( mime, "audio/midi" );
		break;

	case MA_WAV:
			strcpy( mime, "audio/wav" );
		break;

	case MA_WMA:
			strcpy( mime, "audio/wma" );
		break;

	case MA_MP3:
			strcpy( mime, "audio/mp3" );
		break;
	case MA_AMR:
			strcpy( mime, "audio/amr" );
		break;
	}

	if( mime[0] == 0 )	return( NULL );

	return( mime );
}

char *
mediaData_format2extension( int format, char *extension )
{
	switch( format ){
	case MA_MIDI:
			strcpy( extension, ".mid" );
		break;

	case MA_WAV:
			strcpy( extension, ".wav" );
		break;

	case MA_WMA:
			strcpy( extension, ".wma" );
		break;

	case MA_MP3:
			strcpy( extension, ".mp3" );
		break;
	case MA_AMR:
			strcpy( extension, ".amr" );
		break;
	}

	return( extension );
}


/*
int
mediaData_format_from_extension( char *file )
{
char	extension[256];

	gp_filename_extract_extension( file, extension, 256 );

	gp_strlwr(extension);

	return( mediaData_format( extension ) );
}
*/