/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/*********************
 ***	PrmAux.c   ***
 *********************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 
#include "Uigp/igp.h"
#include "prm.h"     




static void	gp_prm_print_parameter(FILE * fd, GP_prm * prm);


void 
gp_prm_dump_defaults_file(char *filename, GP_prm * params, int n_params)
{
FILE   *fp;
GP_prm *prm;
int     n;

	if ((fp = fopen(filename, "a")) == NULL) {
		return;
	}

	fprintf(fp, "\n\n\n" );
	fprintf(fp, "------------\n" );


	for (n = 0; n < n_params; n++) {
		prm = params + n;

		/* dump name of parameter */
		fprintf(fp, "!  \"%s\",\t\t", prm->name);
		fprintf(fp, "\"%s\"\n", prm->default_str);


		/* dump content of parameter */
	}
	fclose(fp);
}



void 
gp_prm_print_params(FILE * fd, GP_prm * params, int n_params)
{
	int     i;
	GP_prm *prm;

	for (i = 0; i < n_params; i++) {
		prm = params + i;
		fprintf(fd, "\n%s ", prm->name);

		gp_prm_print_parameter(fd, prm);
	}
	fprintf(fd, "\n");
}





static void 
gp_prm_print_parameter(FILE * fd, GP_prm * prm)
{

	switch (prm->type) {
		case PRM_INTEGER:fprintf(fd, prm->format,*((int *) prm->value));
	    break;

	case PRM_BOOLEAN:
		if ((*(int *) prm->value) == PRM_BOOLEAN_FALSE)
			fprintf(fd, "True");
		else
			fprintf(fd, "False");
	    break;

	case PRM_FLOAT:
		fprintf(fd, prm->format, *((float *) prm->value));
	    break;

	case PRM_STRING:
		fprintf(fd, prm->format, prm->value);
	    break;
	}
}
