/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/***********************
 ***	PrmGroup.c   ***
 ***********************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
 
#include "Uigp/igp.h"
#include "prm.h"     




void 
gp_prm_group_set_defaults(GP_prm_group * prm_group, int n_groups)
{
	int     i;
	GP_prm *prm;
	int     prm_no;
	void    (*check_func) ();

	for (i = 0; i < n_groups; i++) {
		(prm_group[i].get_prm) (&prm, &prm_no, &check_func);
		gp_prm_set_defaults(prm, prm_no);
	}
}




void 
gp_prm_group_parse_defaults_file(char *filename,
			 GP_prm_group * prm_group, int n_groups)
{
int     i;
GP_prm *prm;
int     prm_no;
void    (*check_func) ();

	for (i = 0; i < n_groups; i++) {
		(prm_group[i].get_prm) (&prm, &prm_no, &check_func);
		gp_prm_parse_defaults_file(filename, prm, prm_no);
	}
}






void 
gp_prm_append(GP_prm prm[], int *prm_no,
	      void (*get_prm) (GP_prm ** prm, int *prm_no,
			       void (**check_func) ()))
{
	GP_prm *cprm;
	int     cprm_no;
	void    (*ccheck_func) ();

	(get_prm) (&cprm, &cprm_no, &ccheck_func);
	memcpy((void *) &prm[*prm_no], (void *) cprm, sizeof(GP_prm) * cprm_no);
	*prm_no += cprm_no;
}
