/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef         GP_TIME
#define         GP_TIME

#include <stdio.h>




#ifdef __cplusplus
extern "C" {
#endif


#include "Uigp/igp.h"


typedef struct gp_time_type {
	int	utime0,	stime0,	cutime0,	cstime0;
	int	sec0,	mil_sec0;

	int	clock0,	clock;

	int	utime,	stime,	cutime,	cstime;
	float	sec;

}	gp_time_type;



void	gp_time_init( gp_time_type *t );

void	gp_time_start( gp_time_type *t );

void	gp_time_add( gp_time_type *t );

void	gp_time_print( FILE *fp, char *string, gp_time_type *t );

void	gp_time_msg( char *string, gp_time_type *t );


int	gp_base_time();

int	gp_time( int base_time );

char *	gp_dateTime_iso681( char *buf, u_int timeStamp );
char *	gp_time_iso681( char *buf, u_int timeStamp );



#ifdef __cplusplus
}
#endif

#endif
