/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#if !defined __DATE_H__
#define __DATE_H__
#include <Winbase.h>


unsigned short CodeDate(PSYSTEMTIME p)
{
	short m[] = {31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334};
	short year = (short)(p->wYear - 2001);
	if (year < 0)
		return 0;
	unsigned short n = (unsigned short)(year * 365.25f);
	if ((p->wMonth > 2)&&(p->wYear & 3 == 0))	//	leap-year 
		for (int i = 1; i < 11; m[i++]++);
	n += (p->wMonth > 1)? m[p->wMonth - 2]: 0;
	n += p->wDay;
	return n;
}

PSYSTEMTIME DecodeDate(unsigned short n)
{
	static SYSTEMTIME s;
	short i;
	short m[] = {31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334};
	memset(&s, 0, sizeof(SYSTEMTIME));
	if (n)
	{
		s.wDayOfWeek = n % 7;
		short year = (short)(n / 365.25f);
		s.wYear = year + 2001;
		n -= (short)(year * 365.25f);
		if (s.wYear & 3 == 0)	//	leap-year 
			for (i = 1; i < 11; m[i++]++);
		for (i = 0; i < 11; i++)
			if (n < m[i]) break;
		s.wMonth = i + 1;
		s.wDay = (i)? n - m[i - 1] : n;
	}
	else
	{
		s.wYear = 2001;
		s.wMonth = 1;
		s.wDay = 1;
	}
	return &s;
}

unsigned short CodeCurrentDate()
{
	SYSTEMTIME s;
	::GetSystemTime(&s);
	return CodeDate(&s);
}
#endif