/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
#ifndef _UNITY_

#define _UNITY_

#include	"Ujet1/Jet1Type.h"
#include	"Ujet2/Jet2Type.h"
#include	"Ujet2/Jet23Type.h"


typedef struct unity_type {
	float	t;
	float	h;
	float	a,	b;
} unity_type;



void	unity_init( unity_type u[], int no );

float	unity_weight( float t, unity_type u[], int no );



	/* UnityS2.c */

void	unity2_set_paramter( float h, float e );

float	unity2_value( float x );

void    unity2_jet1( float x, jet1_type *v );

int	unity2_jet2( jet2 *u, float x, float y );


	/* UnityS3.c */

void	unity3_set_paramter( float h, float e );

float	unity3_value( float x );

void	unity3_jet1( float x, jet1_type *v );

int	unity3_jet23( jet23 *u, float x, float y );


	/* UnityS4.c */

void	unity4_set_paramter( float h, float e );

float	unity4_value( float x );

void	unity4_jet1( float x, jet1_type *v );

int	unity4_jet23( jet23 *u, float x, float y );


#endif /* #ifndef _UNITY_ */
