/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/**********************
 ***	VecTool.c   ***
 **********************/

#include	"Vec2d.h"
#include	<math.h>


void
vec2d_reorder( vec2d V[], int no )
{
vec2d	v,	*v0,	*v1,	*v2;
int	i,	j,	I;
int	flag,	tflag;


        for( i = 1 ; i < no-1 ; i++ ){
                v0 = &V[i-1];
                v1 = &V[i];

                flag = -( v1->x * v0->y + v1->y * -v0->x ) > 0;

                I = i;

                for( j = i+1 ; j < no ; j++ ){
                        v2 = &V[j];
                        tflag = -( v2->x * v0->y + v2->y * -v0->x ) > 0;
                        if( -( v2->x * v1->y + v2->y * -v1->x ) > 0 )
                                tflag |= 0x02;

                        if( (flag == 1 && tflag == 0x01 ) ||
                                (flag == 0 && tflag != 0x02 ) ){

                                I = j;
                                v1 = v2;
                                flag = -( v1->x * v0->y + v1->y * -v0->x ) > 0;                        }
                }

                if( i == I )    continue;

                v = V[i];
                V[i] = V[I];
                V[I] = v;
        }
}

int
vec2d_select( vec2d V[], int no, vec2d *p )
{
vec2d	*v;
int	i,	flag,	tflag;

	v = &V[0];
	flag = ( -p->x * v->y + p->y * v->x ) > 0;


	for( i = 1 ; i < no ; i++ ){
		v = &V[i];
		tflag = ( -p->x * v->y + p->y * v->x ) > 0;

		if( flag == 1 && tflag == 0 )	return( i -1 );

		flag = tflag;
	}

	return( no-1 );
}



float
vec2d_distance( vec2d *v0 ,vec2d *v1 )
{
vec2d	dv;
float	dis;

	dv.x = v0->x - v1->x;
	dv.y = v0->y - v1->y;
	dis = hypot( dv.x, dv.y );

	return( dis );
}


float
vec2d_distance2( vec2d *v0 ,vec2d *v1 )
{
vec2d	dv;
float	dis;

	dv.x = v0->x - v1->x;
	dv.y = v0->y - v1->y;
	dis = dv.x*dv.x + dv.y*dv.y;

	return( dis );
}


/*
int
vec2d_select( vec2d V[], int no, vec2d *p )
{
vec2d	*v;
int	i,	flag,	tflag;

	v = &V[0];
	flag = ( p->x * v->y + p->y * -v->x ) > 0;


	for( i = 1 ; i < no ; i++ ){
		v = &V[i];
		tflag = ( p->x * v->y + p->y * -v->x ) > 0;

		if( flag != tflag )	return( i-1 );

		flag = tflag;
	}

	return( no );
}
*/