/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
/********************************************************
*							*
*		PerDump.c				*
*							*
********************************************************/
#include	<stdio.h>

#include	"ViewType.h"


void
view_dumps( char *dir, char *fname, view_type *vw[], int vw_no )
{
char	file[256];
int	i;

	for( i = 0 ; i < vw_no ; i++ ){

		sprintf( file, "%s-%d", fname, i );

		view_dump( dir, file, vw[i] );
	}
}


void
view_dump( char *dir, char *fname, view_type *vw )
{
char	file[256];
FILE	*fp;

	sprintf( file, "%s/%s.view", dir, fname );

	fp = fopen( file, "w" );

	fprintf( fp, "!  \"%s\"		\"%d\"\n", "V-type",  vw->type );
	fprintf( fp, "!  \"%s\"		\"%.2f\"\n", "V-Ang",  vw->angle );
	fprintf( fp, "!  \"%s\"		\"%.2f\"\n", "V-Dis",  vw->dis );

	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-Cp-x",  vw->cp.x );
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-Cp-y",  vw->cp.y );
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-Cp-z",  vw->cp.z );

	fprintf( fp, "!  \"%s\"		\"%d\"\n", "V-N-flag",  1);
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-N-x",  vw->N.x );
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-N-y",  vw->N.y );
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-N-z",  vw->N.z );


	fprintf( fp, "!  \"%s\"		\"%d\"\n", "V-v-flag",  1);
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-v-x",  vw->V.x );
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-v-y",  vw->V.y );
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-v-z",  vw->V.z );


	fprintf( fp, "!  \"%s\"		\"%d\"\n", "V-w-flag",  0);
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-U0",  vw->uv.x0 );
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-U1",  vw->uv.x1 );
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-V0",  vw->uv.y0 );
	fprintf( fp, "!  \"%s\"		\"%.4f\"\n", "V-V1",  vw->uv.y1 );


	fprintf( fp, "!  \"%s\"		\"%d\"\n", "V-pixel",  vw->Vpixel );
	fprintf( fp, "!  \"%s\"		\"%d\"\n", "U-pixel",  vw->Upixel );

	fprintf( fp, "!  \"%s\"		\"%d\"\n", "V-p0",  0 );
	fprintf( fp, "!  \"%s\"		\"%d\"\n", "U-p0",  0 );

	fclose( fp );
}
