/***********************************************************************
This software module was originally developed by Yoram Elichai
(Vimatix Inc.) in the course of development of the MPEG-4
Systems (ISO/IEC 14496-1) standard. This software module is an implementation
of a part of one or more MPEG-4 Systems (ISO/IEC 14496-1) tools as
specified by the MPEG-4 Systems (ISO/IEC 14496-1) standard. ISO/IEC
gives users of the MPEG-4 Systems (ISO/IEC 14496-1) free license to
this software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-4 Systems (ISO/IEC
14496-1). Those intending to use this software module in hardware or
software products are advised that its use may infringe existing patents.
The original developer of this software module and his/her company, the
subsequent editors and their companies, and ISO/IEC have no liability
for use of this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4 Systems
(ISO/IEC 14496-1) conforming products. Vimatix Inc. retains full right
to use the code for his/her own purpose, assign or donate the code to a
third party and to inhibit third parties from using the code for non
MPEG-4 Systems (ISO/IEC 14496-1) conforming products. This copyright
notice must be included in all copies or derivative works.
Copyright  2003
************************************************************************

For more information or to receive an up to date version of this module,
you may contact Yoram Elichai at yorame@vimatix.com .
----------------------------------------------------------------------*/
// DtTree.cpp : Defines the entry point for the DLL application.
//

//#include "stdafx.h"

#ifdef WIN32
#include <windows.h>
#endif

#ifdef _MANAGED
#pragma managed(push, off)
#endif

extern "C" {
#include	"CorTransform/CorTransform.h"
#include	 "Filter/Filter.h"
};

#include	"VimTransform.h"

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    return TRUE;
}



static int	progress( int i, int no );


VIM_TRANSFORM_API int vim_transform( image_type *im, int filter, gp_array **agp )
{

	if( im->row > 240 || im->column > 320 )
		return( -1 );

	*agp = cor_transform( im, 0, 6, "D", 0, progress);

	if( *agp == NULL )
		return( -1 );

	filter_percent_agp( *agp, NULL, filter*10, filter*10 );


	fprintf( stderr, "\n" );



	return( 1 );
}



VIM_TRANSFORM_API void vim_release( gp_array *agp )
{
	agp_destroy( agp );
}

static int
progress( int i, int no )
{
	fprintf( stderr, " ." );

	return( 1 );
}




#ifdef _MANAGED
#pragma managed(pop)
#endif

